#!/bin/sh
exec perl -x. $0 ${1+"$@"} 

#!perl

$topdir=$ARGV[0];

open (P, "grep = `find $topdir -name Makefile.in`|");
$_=$type;
while (<P>) {
	if (/^$topdir\/([^:]*)\/[^:]*\/Makefile\.in:\s*SO\s*=\s*(.*)\s*$/) {
	next if /mnemonic-core/;
	$lib{$1}=$2;
   }
}
close (P);

$_=$type;
foreach $dir (keys %lib) {
	$headers="";
	open (P, "echo `ls $topdir/$dir/src/*.h*`|");
	while (<P>) {
		$headers=$headers." ".$_;
	}
	close(P);
	open (P, "echo `ls $topdir/$dir/src/*.cc`|");
	while (<P>) {
		$headers=$headers." ".$_;
	}
	close(P);
	@hdrs = split(/\s/, $headers);
	@{ $content{$dir} }=();
	@{ $depends{$dir} }=();
	@{ $debugflags{$dir} }=();
	foreach $hdrfile (@hdrs) {
		$_=$hdrfile;
		push @{ $content{$dir} }, ($1);
		open(HEADER, "<".$_);
		while (<HEADER>) {
			if ( /.define DEBUG_CLASS .(.*)./ ) {
				 if ( !grep(/$1/, @{ $debugflags{$dir} }) ) {
 				   push @{ $debugflags{$dir} }, ($1);
			  }
			}
			if ( /.include .*msg\/([^\/]*)\/([^\/]*)\.h/ ) {
				if ( !grep(/mnemonic-msg-$1/, @{ $depends{$dir} }) ) {
					push @{ $depends{$dir} }, ("mnemonic-msg-".$1);
				}
			}
#			if ( /.include .*msg\/([^\/]*)\/([^\/]*)\.h/ ) {
#				push @{ $sends{$dir} }, ($2);
#			}
			if ( /interest.*[ ,](m[^>^,^ ]*)[>, ]/ ) {
				if ( !grep(/$1/, @{ $receives{$dir} }) ) {
					push @{ $receives{$dir} }, ($1);
				}
			}
		}
		close(HEADER);
	}
}

print "%title%\n";
print "Support Libraries\n\n";
print "%pagename%\n";
print "Support Libraries\n\n";

print "%body%\n";
print "<!-- _GP_ section_header('Overview') -->\n";

print "<table border=1 cellpadding=5 width=\"100%\">\n<tr bgcolor=\"#dddddd\" color=\"#000000\">";
print "<th align=left>name</th>";
#print "<th align=left>docs</th>";
#print "<th align=left>download code</th>";
print "<th align=left>depends on module</th>";
#print "<th align=left>debug flags</th>";
print "</tr>";
foreach $dir (keys %lib) {
	$version{dir}="0.1.1";
	print "<tr><td valign=top>";
	if(open(P, "<../../".$dir."/doc/content/overview.content")) {
		close(P);
		print "<a href=\"../../../".$dir."/doc/www/overview.html\">";
		print $dir."</a>";
	}
	else {
		print $dir;
	}
#	print "</td>\n    <td valign=top>";
#	foreach $mess (@{ $receives{$dir} }) {
#		if (@{ $receives{$dir} } == 0) {
#			print "&nbsp;";
#		}
#		else {
#			print $mess."<br>\n";
#		}
#	}
	print "</td>\n";
#	print "<td valign=top>"."<a href=\"../".$dir."/doc/index.html\">html</a> (online)</td>\n";
#	print "<td valign=top>\n";
#	print "    <a href=\"\">".$dir.$version{$dir}."-bin.tar.gz</a><br>\n";
#	print "    <a href=\"\">".$dir.$version{$dir}.".rpm</a><br>\n";
#	print "    <a href=\"\">".$dir.$version{$dir}.".deb</a><br>\n";
#	print "<br>for developers:<br>";
#	print "    <a href=\"\">".$dir.$version{$dir}."-src.tar.gz</a><br>\n";
#	print "    <a href=\"\">".$dir.$version{$dir}."-devel.rpm</a><br>\n";
#	print "    <a href=\"\">".$dir.$version{$dir}."-src.deb</a><br>\n";
#	print "</td>\n";
	print "<td valign=top>";
	if (@{ $depends{$dir} } == 0) {
		print "&nbsp;";
	}
	foreach $dep (@{ $depends{$dir} }) {
		print $dep."<br>";
	}
	print "</td>\n";
#	print "<td valign=top>";
#	if (@{ $debugflags{$dir} } == 0) {
#		print "&nbsp;";
#	}
#	foreach $dep (@{ $debugflags{$dir} }) {
#		print $dep."<br>";
#	}
#	print "</td>\n";
	print "</tr>\n";
}
print "</table>\n";


