#!/bin/sh
exec perl -x. $0 ${1+"$@"} 

#!perl

$topdir=$ARGV[0];

open (P, "grep = `find $topdir -name Makefile.in`|");
$_=$type;
while (<P>) {
	if (/^$topdir\/([^:]*)\/[^:]*\/Makefile\.in:\s*MSGS\s*=\s*(.*)\s*$/) {
		$msg{$1}=$2;
	}
}
close (P);

$_=$type;
foreach $dir (keys %msg) {
	$headers="";
	$alsostr="";
	if(open(P, "<../".$dir."/debian/control")) {
		$descr="";
		while(<P>) {
			if (/Depends[:\s]*(.*)/) {
				 s/..shlibs[~\s]*//;
				 $alsostr=$1;
			}
		}
		close(P);
	}
	@{ $alsoreq{$dir} }=split(/,/, $alsostr);
	open (P, "echo `ls $topdir/$dir/include/msg/*/*.h*`|");
	while (<P>) {
		$headers=$headers." ".$_;
	}
	close(P);
	open (P, "echo `ls $topdir/$dir/src/*.cc`|");
	while (<P>) {
		$headers=$headers." ".$_;
	}
	close(P);
	@hdrs = split(/\s/, $headers);
	@{ $content{$dir} }=();
	@{ $depends{$dir} }=();
	@{ $debugflags{$dir} }=();
	foreach $hdrfile (@hdrs) {
		$_=$hdrfile;
		if ( $hdrstrip=(/.*\/([^\/~]*)\.hh*$/) ) {
			 push @{ $content{$dir} }, ("msg_$1");
		}
		open(HEADER, "<".$_);
		while (<HEADER>) {
			if ( /.define DEBUG_CLASS .(.*)./ ) {
				push @{ $debugflags{$dir} }, ($1);
			}
			if ( /.include .*msg\/([^\/]*)\// ) {
				if ( !grep(/$1/, @{ $depends{$dir} }) ) {
					if ( ( $dir cmp "msg_".$1 ) ) {
						push @{ $depends{$dir} }, ("msg_".$1);
					}
				}
			}
		}
		close(HEADER);
	}
}



print "%title%\n";
print "C++ Messages\n\n";
print "%pagename%\n";
print "C++ Messages\n\n";

print "%body%\n";
print "<!-- _GP_ section_header('Overview') -->\n";

print "<table border=1 cellpadding=5 width=\"100%\"><tr bgcolor=\"#dddddd\" color=\"#000000\">";
print "<th align=left>name</th>";
print "<th align=left>message classes</th>";
#print "<th align=left>docs</th>";
#print "<th align=left>download code</th>";
print "<th align=left>depends on module</th>";
#print "<th align=left>also requires</th>";
#print "<th align=left>debug flags</th>";
print "</tr>";
foreach $dir (keys %msg) {
	$version{dir}="0.1.1";
	print "<tr><td valign=top>";
	if(open(P, "<../../".$dir."/doc/content/overview.content")) {
		close(P);
		print "<a href=\"../../../".$dir."/doc/www/overview.html\">";
		print $dir."</a>";
	}
	else {
		print $dir;
	}
	print "</td>";
	print "<td colspan=2>";
	if(open(P, "<../".$dir."/debian/control")) {
		$descr="";
		while(<P>) {
			if (/Description[:\s]*(.*)/) {
				$descr=$1;
			}
		}
		close(P);
		print $descr;
	}
	else {
		print "(no description)";
	}
	print "</td></tr>\n";
    print "<td>&nbsp;</td><td valign=top>";
	foreach $mess (@{ $content{$dir} }) {
		if(open(P, "<../".$dir."/doc/".$mess.".html")) {
			close(P);
			print "<a href=\"../".$dir."/doc/".$mess.".html\">";
			print $mess."</a><br>\n";
		}
		else { 			
			print $mess."<br>\n";
		}
	}
	print "</td>\n";
#	print "<td valign=top>"."<a href=\"../".$dir."/doc/index.html\">html</a> (online)</td>\n";
#	print "<td valign=top>\n";
#	print "    <a href=\"\">".$dir.$version{$dir}."-bin.tar.gz</a><br>\n";
#	print "    <a href=\"\">".$dir.$version{$dir}.".rpm</a><br>\n";
#	print "    <a href=\"\">".$dir.$version{$dir}.".deb</a><br>\n";
#	print "<br>for developers:<br>";
#	print "    <a href=\"\">".$dir.$version{$dir}."-src.tar.gz</a><br>\n";
#	print "    <a href=\"\">".$dir.$version{$dir}."-devel.rpm</a><br>\n";
#	print "    <a href=\"\">".$dir.$version{$dir}."-src.deb</a><br>\n";
#	print "</td>\n";
	print "<td valign=top>";
	if (@{ $depends{$dir} } == 0) {
		print "&nbsp;";
	}
	foreach $dep (@{ $depends{$dir} }) {
		print $dep."<br>";
	}
#	print "</td><td valign=top>";
#	if (@{ $alsoreq{$dir} } == 0) {
#		print "&nbsp;";
#	}
#	foreach $also (@{ $alsoreq{$dir} }) {
#		print $also."<br>";
#	}
#	print "</td>\n";
#	print "<td valign=top>";
#	if (@{ $debugflags{$dir} } == 0) {
#		print "&nbsp;";
#	}
#	foreach $dep (@{ $debugflags{$dir} }) {
#		print $dep."<br>";
#	}
#	print "</td>\n";
	print "</tr>\n";
}
print "</table>\n";

