#!/bin/sh
exec perl -x. $0 ${1+"$@"} 

#!perl

$topdir=$ARGV[0];

open (P, "grep = `find $topdir -name Makefile.in`|");
$_=$type;
while (<P>) {
	if (/^$topdir\/([^:]*)\/[^:]*\/Makefile\.in:\s*MSGS\s*=\s*(.*)\s*$/) {
		$msg{$1}=$2;
	}
}
close (P);

$_=$type;
foreach $dir (keys %msg) {
	$headers="";
	$alsostr="";
	if(open(P, "<../".$dir."/debian/control")) {
		$descr="";
		while(<P>) {
			if (/Depends[:\s]*(.*)/) {
				$alsostr=$1;
			}
		}
		close(P);
	}
	@{ $alsoreq{$dir} }=split(/,/, $alsostr);
	open (P, "echo `ls $topdir/$dir/include/msg/*/*.h*`|");
	while (<P>) {
		$headers=$headers." ".$_;
	}
	close(P);
	open (P, "echo `ls $topdir/$dir/src/*.cc`|");
	while (<P>) {
		$headers=$headers." ".$_;
	}
	close(P);
	@hdrs = split(/\s/, $headers);
	@{ $content{$dir} }=();
	@{ $depends{$dir} }=();
	@{ $debugflags{$dir} }=();
	foreach $hdrfile (@hdrs) {
		$_=$hdrfile;
		if ( $hdrstrip=(/.*\/(m[^\/~]*).h$/) ) {
			push @{ $content{$dir} }, ($1);
		}
		open(HEADER, "<".$_);
		while (<HEADER>) {
			if ( /.define DEBUG_CLASS .(.*)./ ) {
				push @{ $debugflags{$dir} }, ($1);
			}
			if ( /.include .*msg\/([^\/]*)\// ) {
				if ( !grep(/$1/, @{ $depends{$dir} }) ) {
					if ( ( $dir cmp "msg_".$1 ) ) {
						push @{ $depends{$dir} }, ("msg_".$1);
					}
				}
			}
		}
		close(HEADER);
	}
}

print "SECTION([Table of Messages], [\n";
print"<hr>";
print "<font size=-1>";
foreach $dir (keys %msg) {
    my $firstcontent=0;
    my $firstdepends=0;
    my $firstalsoreq=0;
    my $firstdebug=0;

    $version{dir}="0.1.1";
    if(open(P, "<../".$dir."/doc/overview.content")) {
	close(P);
	print "<p><strong>Name:</strong> <a href=\"../".$dir."/doc/overview.html\">";
	print "$dir </a>";
    }
	else {
		print "<p><strong>Name:</strong> $dir";
	}
	if(open(P, "<../".$dir."/debian/control")) {
		$descr="";
		while(<P>) {
			if (/Description[:\s]*(.*)/) {
				$descr=$1;
			}
		}
		close(P);
		print "<p><strong>Description:</strong> $descr";
	}
	else {
		print "<p><strong>Description:</strong> (no description)";
	}
	foreach $mess (@{ $content{$dir} }) {
		if(open(P, "<../".$dir."/doc/".$mess.".html")) {
			close(P);
			if ($firstcontent==0) {
			    print "<p><strong>Contents:</strong><br>";
			    $firstcontent=1;
			}
			print "<a href=\"../".$dir."/doc/".$mess.".html\">";
			print "$mess </a><br>\n";
		}
		else { 			
		    if ($firstcontent==0) {
			print "<p><strong>Contents:</strong><br>";
			$firstcontent=1;
		    }
			print "$mess <br>\n";
		}
	}
	print "<p><strong>Download:</strong><br>    <a href=\"\">".$dir.$version{$dir}."-bin.tar.gz</a><br>\n";
	print "            <a href=\"\">".$dir.$version{$dir}.".rpm</a><br>\n";
	print "            <a href=\"\">".$dir.$version{$dir}.".deb</a><br>\n";
	print "        <br>for developers:<br>";
	print "            <a href=\"\">".$dir.$version{$dir}."-src.tar.gz</a><br>\n";
	print "            <a href=\"\">".$dir.$version{$dir}."-devel.rpm</a><br>\n";
	print "            <a href=\"\">".$dir.$version{$dir}."-src.deb</a><br>\n";
	if (@{ $depends{$dir} } == 0) {
		print "<p><strong>Depends on:</strong> &nbsp;";
	}
	foreach $dep (@{ $depends{$dir} }) {
	    if ($firstdepends==0) {
		print "<p><strong>Depends on:</strong><br>";
		$firstdepends=1;
	    }
	    print "$dep <br>";
	}
        if (@{ $alsoreq{$dir} } == 0) {
	    print "<p><strong>Also Requires:</strong> &nbsp;";
	}
        foreach $also (@{ $alsoreq{$dir} }) {
	    if ($firstalsoreq==0) {
		print "<p><strong>Also Requires:</strong><br>";
		$firstalsoreq=1;
	    }
	    print "$also <br>";
	}
	if (@{ $debugflags{$dir} } == 0) {
		print "<p><strong>Debug Flags:</strong> &nbsp;";
	}
	foreach $dep (@{ $debugflags{$dir} }) {
	    if ($firstdebug==0) {
		print "<p><strong>Debug Flags:</strong><br>";
		$firstdebug=1;
	    }
	    print  "$dep <br>";
	}
	print "<hr>\n";
}
print "</font>\n";
print "])\n";

