#!/bin/sh
exec perl -x. $0 ${1+"$@"} 

#!perl

$topdir=$ARGV[0];

open (P, "grep = `find $topdir -name Makefile.in`|");
$_=$type;
while (<P>) {
	if (/^$topdir\/([^:]*)\/[^:]*\/Makefile\.in:\s*OIL\s*=\s*(.*)\s*$/) {
		$oil{$1}=$2;
	}
}
close (P);

$_=$type;
foreach $dir (keys %oil) {
	$headers="";
	open (P, "echo `ls $topdir/$dir/src/*.h*`|");
	while (<P>) {
		$headers=$headers." ".$_;
	}
	close(P);
	open (P, "echo `ls $topdir/$dir/src/*.cc`|");
	while (<P>) {
		$headers=$headers." ".$_;
	}
	close(P);
	@hdrs = split(/\s/, $headers);
	@{ $content{$dir} }=();
	@{ $depends{$dir} }=();
	@{ $debugflags{$dir} }=();
	foreach $hdrfile (@hdrs) {
		$_=$hdrfile;
		push @{ $content{$dir} }, ($1);
		open(HEADER, "<".$_);
		while (<HEADER>) {
			if ( /.define DEBUG_CLASS .(.*)./ ) {
				 if ( !grep(/$1/, @{ $debugflags{$dir} }) ) {
 				   push @{ $debugflags{$dir} }, ($1);
			  }
			}
			if ( /.include .*msg\/([^\/]*)\/([^\/]*)\.h/ ) {
				if ( !grep(/mnemonic-msg-$1/, @{ $depends{$dir} }) ) {
					push @{ $depends{$dir} }, ("mnemonic-msg-".$1);
				}
			}
#			if ( /.include .*msg\/([^\/]*)\/([^\/]*)\.h/ ) {
#				push @{ $sends{$dir} }, ($2);
#			}
			if ( /interest.*[ ,](m[^>^,^ ]*)[>, ]/ ) {
				if ( !grep(/$1/, @{ $receives{$dir} }) ) {
					push @{ $receives{$dir} }, ($1);
				}
			}
		}
		close(HEADER);
	}
}

print "SECTION([Table of OILs], [\n";
print"<hr>";
print "<font size=-1>";
foreach $dir (keys %oil) {
    my $firstinterest=0;
    my $firstdepends=0;
    my $firstdebug=0;

	$version{dir}="0.1.1";

	if(open(P, "<../".$dir."/doc/overview.content")) {
		close(P);
		print "<strong>Name:</strong> <a href=\"../".$dir."/doc/overview.html\">";
		print $dir."</a>";
	}
     
	else {
		print "<strong>Name:</strong> $dir";
	}
	foreach $mess (@{ $receives{$dir} }) {
		if (@{ $receives{$dir} } == 0) {
			print "<strong>Interests:</strong>&nbsp;";
		}
		else {
		    if ($firstinterest==0) {
			    print "<p><strong>Interests:</strong><br>";
			    $firstinterest=1;
			}
			print $mess."<br>\n";
		}
	}

	print "<p><strong>Download:</strong><br>    <a href=\"\">".$dir.$version{$dir}."-bin.tar.gz</a><br>\n";
	print "    <a href=\"\">".$dir.$version{$dir}.".rpm</a><br>\n";
	print "    <a href=\"\">".$dir.$version{$dir}.".deb</a><br>\n";
	print "<br>for developers:<br>";
	print "    <a href=\"\">".$dir.$version{$dir}."-src.tar.gz</a><br>\n";
	print "    <a href=\"\">".$dir.$version{$dir}."-devel.rpm</a><br>\n";
	print "    <a href=\"\">".$dir.$version{$dir}."-src.deb</a><br>\n";
	if (@{ $depends{$dir} } == 0) {
		print "<p><strong>Depends on:</strong> &nbsp;";
	}
	foreach $dep (@{ $depends{$dir} }) {
	    if ($firstdepends==0) {
		print "<p><strong>Depends on:</strong><br>";
		$firstdepends=1;
	    }
	    print "$dep <br>";
	}
	if (@{ $debugflags{$dir} } == 0) {
		print "<p><strong>Debug Flags:</strong> &nbsp;";
	}
	foreach $dep (@{ $debugflags{$dir} }) {
	    if ($firstdebug==0) {
		print "<p><strong>Debug Flags:</strong><br>";
		$firstdebug=1;
	    }
	    print  "$dep <br>";
	}
	print "<hr>";
}
print "</font>\n";
print "])\n";




