theINCLUDE

theHEADER( Mnemonic Debug class )

SECTION([Debug], [
For debugging purposes, the Mnemonic core uses the following
mechanism.
<p>
The debug support has to be compiled in to work this is enabled by adding the
--enable-debug switch to the configure line. Without this all debug code
which is created by the following method is not included into the binary.

<p>
In every file #define DEBUG_CLASS to a appropreate value before 
including debug.h, like this:

<pre>
        #define DEBUG_CLASS "Class"
        #include "debug.h"
</pre>

This is the class for the messages in that file and will later be used
to specify if they should be turned on or off.
<p>
You can then turn on debugmessages for this <Class> with a 
call like debugger.instance().turn_on("Class"). Most test programs specify
a "-dClass" option. If for Class is used "all" then all messages are
displayed.
<p>   
After this you will be able to print your debug messages using the 
function debug. It works like the cerr command.
<pre>
        debug(this<<" test");
</pre>
This prints the following line.
<pre>
(1024/918426170:82220)thread_cond.cc:37: 0x8056d80 test
</pre>
The first number indicates the thread in which the "debug" command is
called. The second combination is the current time. Then the filename and
the line number is shown. And at last the specified data is shown. In this
case the pointer to the class and the message "test".
])
