theINCLUDE

theHEADER( Mnemonic OIL HOWTO )

SECTION([Overview], [

The OIL core is a small C++ library that implements a message based
communication system. It consists of roughly two distinguishable parts.
<p>
The first one is meant to provide programs with the ability to send
data or instructions to multiple receiving objects, where the number
need not be known at compile time. To achieve this, a number of very
easy to use message classes is available, capable of communicating
arbitrary user-defined classes.
<p>
The second part contains the code necessary to load modules on-demand,
automatically registering their interests in receiving particular
types of messages. This functionality is based on ELF dynamic loading,
but wrapped in easy to use C++ classes. Each OIL comes with a `interest'
module, which contains the code necessary to load the true OIL.
<br>
])

SECTION([Mnemonic core libraries], [
The functionality of the Mnemonic core resides in two shared libraries,
to which your program should be linked: <tt>libmnutils.so</tt> and
<tt>libobjectmanager.so</tt>. The former contains miscellaneous 
support code, while the latter contains the code required to 
dynamically load OILs. 
<p>
These libraries are independent of the particular project for which 
they are used. They can, for example, be shared by the Mnemonic 
browser as well as a number of other programs unrelated to the
Mnemonic project. Therefore, they are preferably installed somewhere
in /usr/local/lib.
])

SECTION([Installation directories], [
As described above, the two Mnemonic core libraries go into some
global directory, so these are usually searched by the dynamic linker.
As far as the message libraries go, these have to be put in the
LD_LIBRARY_PATH. Usually, this means something like
<pre>
setenv LD_LIBRARY_PATH /home/me/.testmm/msgs:${LD_LIBRARY_PATH}
</pre>
])

SECTION([Messages], [
This section not completed
])

SECTION([Object Implementation Libraries], [
This section not completed
])

SECTION([Distribution], [
All OILs should be distributed as a single tar file, which contains 
one 'oilname.oil' file and one or more 'oil_interest.oil' files.
These can be placed in the '~/.mnemonic/oil' directory. The interest
file contains the logic which determines dynamic loading; removing it
from the '~/.mnemonic/oil' directory disables the corresponding OIL.
Each such interest file can contain its own configuration logic; that's
up to the author of the OIL.


<pre>
include @prefix@/share/mnemonic/Mnemonic.Make.vars

OIL              = (name of oil without .oil postfix)
OILFILES         = (.o files)
OILINTEREST_LIBS = (additional libraries linked to interest oil)
OIL_LIBS         = (additional libraries linked to oil itself)
EXTRA_INCLUDES   = (paths to additional header files)

include @prefix@/share/mnemonic/Mnemonic.Rules.make
])

theFOOTER

