// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Debug wrappers (through which debugging can be turned off completely).

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef DEBUG_H
#define DEBUG_H


#include <mnemonic/optionals.h>
#include <string>

#define nod() debug(this)

#ifdef DEBUG
  #include <iostream.h>
  #define debug(xxx) { if (debugger::instance().check_debug_class(DEBUG_CLASS)) { strstream strs; debugger::instance().stamp(strs,__FILE__, __LINE__); strs << xxx << endl<<ends; debugger::instance().lock(); char *c=strs.str();cerr<<c; delete[] c; debugger::instance().unlock(); }}
  #include "debugger.hh"
  #include "memdebug.hh"
#else
  #define debug(x) 
#endif

#endif






