// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Mnemonic debugging output routines, interface.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef debugger_hh__
#define debugger_hh__

#include <string>
#include <strstream>
#include <mnemonic/optionals.h>
#include <map.h>
#include <pthread.h>
#include <mnemonic/thread_mutex.hh>

#ifdef DEBUG

class debugger {
   public:
      static debugger& instance(void);
      void turn_on(const char *cl);
      void turn_off(const char *cl);
		void lock(void);
		void unlock(void);
      bool check_debug_class(const char *cl) const;
		void stamp(strstream &str,const char *file, int line) const;
      void setsighandler(void);
   private:
      debugger(void);
      static debugger     *instance_;
      map<string,bool>     debugmod_;
		mutable thread_mutex l_mutex;	  
};

#endif
#endif
