// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Mnemonic unique identifier code. Each freshly created midentifier
  is unique. Threadsafe.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef midentifier_hh__
#define midentifier_hh__

#include <iostream>
#include "mnemonic/thread_mutex.hh"

class midentifier {
	public:
		midentifier();
		midentifier(const midentifier &);
		int operator==(const midentifier &) const;
		bool operator<(const midentifier &) const;
		midentifier &operator=(const midentifier &);
		friend ostream& operator<<(ostream&,const midentifier &);
	private:
		long count_;
		static thread_mutex mutex_;
		static long         maxcount_;
};

ostream& operator<<(ostream&,const midentifier &);

#endif
