// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Mnemonic thread wrapper classes for portable threads.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef nthread_hh__
#define nthread_hh__

#include <pthread.h>
#include "thread_type.hh"
#include "thread_cond.hh"

class thread_cond;
class thread;

class thread {
	public:
		thread(void);
		virtual     ~thread();
		void	       start(void);
		void	       stop(void);
		virtual void begin(void)=0;
		virtual		 void cancel();

		friend void *threadstart(void *);
	private:
		void	       prebegin();
		pthread_t    rthread;
		thread_cond  thr_;
		int	       ok_;
};

#endif
