// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Thread mutexes, interface.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef nthreadmutex_hh__
#define nthreadmutex_hh__

#include <pthread.h>
#include "thread_type.hh"

// The thread_mutex class uses error-checking mutexes by default, ie
// if you lock or unlock twice or if you unlock something that was not
// locked, an exception is thrown. You can opt for a recursive one though.

class thread_mutex {
	public:
#ifdef __USE_UNIX98
		thread_mutex(int type=PTHREAD_MUTEX_ERRORCHECK); 
                              // one of PTHREAD_MUTEX_ERRORCHECK (default)
		                        //        PTHREAD_MUTEX_RECURSIVE
		                        //        PTHREAD_MUTEX_FAST
#else
		thread_mutex(int type=1);
#endif
		int   	lock(void);
		bool  	trylock(void); 		// returns true if you got the lock
		int   	unlock(void);
		virtual ~thread_mutex();
	protected:
		pthread_mutex_t mutex;
};

#endif
