#
# Rules for compilation of the Mnemonic core.
#
# (NOTE: these are not for public consumption, see Mnemonic.Rules.make
#  for that).

all: $(COREOBJS) $(SO) $(LOCALEXES) $(LOCALRULES) subdirs

%.o: %.cc
	$(CPLUSPLUS) $(CFLAGS) $(GCFLAGS) $(PROFILE) -fPIC -c -o $@ $<

ifneq ($(strip $(SO)),)
$(SO): $(SOFILES)
	@PATH=..:$(PATH) \
	$(MNEMONIC_ROOT)/mnemonic-createlib $(SO) $(VERSION).$(PATCHLEVEL).$(SUBLEVEL) $(VERSION).$(PATCHLEVEL) \
                                       $(SOFILES) $(PROFILE) $(SOLIBS)
	ln -fs $(SO).$(VERSION).$(PATCHLEVEL).$(SUBLEVEL) $(SO).$(VERSION).$(PATCHLEVEL)
	ln -fs $(SO).$(VERSION).$(PATCHLEVEL) $(SO)
endif

depend:
	if [ "$(wildcard *.cc)" != "" ]; then \
		$(DEPEND) $(wildcard *.cc) > .depend; \
	fi
	list="$(SUBDIRS)"; for subdir in $$list; do \
		(cd $$subdir && $(MAKE) depend); \
	done

subdirs:
	list="$(SUBDIRS)"; set -e; for subdir in $$list; do \
	  $(MAKE) -C $$subdir all $(EXPORT); \
	done

clean:
	-rm -f stamp-h
	-rm -f $(SOFILES)
	-rm -f *.o *~ *.a core
	-rm -f *.so* 
	-rm -f dlopentest 
	list="$(SUBDIRS)"; for subdir in $$list; do \
	  (cd $$subdir && $(MAKE) $(EXPORT) clean); \
	done

distclean:
	-rm -f optionals.h
	list="$(SUBDIRS)"; for subdir in $$list; do \
		(cd $$subdir && $(MAKE) $(EXPORT) distclean); \
	done
	$(MAKE) clean
	-rm -f Makefile config.h .depend Make.vars Mnemonic.Make.vars optionals.h

ifeq (.depend,$(wildcard .depend))
include .depend
endif


