#include "mnemonic/priority_list.hh"

main() {
	priority_list<char> lst;
	priority_list<char>::iterator i,j,t;

	cout << "Test1: Single insertion\n";
	lst.insert(1,'a');

	for (i=lst.begin(); i!=lst.end(); i++) {
		cout << "Node: " << *i << endl;
	}

	cout << "\nTest2: Multiple insertion\n";
	lst.insert(1,'a');
	lst.insert(2,'b');
	lst.insert(3,'c');
	lst.insert(4,'d');
	
	for (i=lst.begin(); i!=lst.end(); i++) {
		cout << "Node: " << *i << endl;
	}

	cout << "\nTest3: Multiple insertion in reverse\n";
	lst.insert(4,'d');
	lst.insert(3,'c');
	lst.insert(2,'b');
	lst.insert(1,'a');
	
	for (i=lst.begin(); i!=lst.end(); i++) {
		cout << "Node: " << *i << endl;
	}

	cout << "\nTest4: Removing items before/after iterator\n";

	i=lst.begin();
	i++;
	
	j=lst.begin();
	j++;
	j++;

	for (; i!=lst.end(); i++) {
		cout << "Node: " << *i << endl;

		t=j;
		j++;
		j++;

		lst.erase(t);
		lst.erase(lst.begin());
	}

	cout << "Left:\n";
	for (i=lst.begin(); i!=lst.end(); i++) {
		cout << "Node: " << *i << endl;
	}

	cout << "\nTest5: Adding items while iterating (not first)\n";
	int pri1=7;
	int pri2=10;
	for (i=lst.begin(); i!=lst.end(); i++) {
		cout << "Node: " << *i << endl;
		lst.insert(pri1,'A'+pri1);
		lst.insert(pri2,'a'+pri2);
		pri1--; pri2--;
	}

	cout << "Left:\n";
	for (i=lst.begin(); i!=lst.end(); i++) {
		cout << "Node: " << *i << endl;
	}

	cout << "\nTest6: Removing items pointed to by iterator (not first)\n";

	i=lst.begin();
	i++;

	for (; i!=lst.end(); i++) {
		cout << "Before: "<< *i << endl;
		lst.erase(i);
		cout << "After: "<< *i << endl;
	}

	cout << "Left:\n";
	for (i=lst.begin(); i!=lst.end(); i++) {
		cout << "Node: " << *i << endl;
	}

	// We need some more data to play with...
	lst.insert(3,'c');
	lst.insert(2,'b');
	lst.insert(1,'a');

	cout << "\nTest6: Removing iterator pointing to first node\n";
	for (i=lst.begin(); i!=lst.end(); i++) {
		cout << "Killing " << *i << endl;
		lst.erase(i);
		if (i==lst.end()) cout << "Bad!\n";
	}

	cout << "Left:\n";
	for (i=lst.begin(); i!=lst.end(); i++) {
		cout << "Node: " << *i << endl;
	}
}
