// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Mnemonic unique identifier code implementation.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "mnemonic/midentifier.hh"

midentifier::midentifier() 
	{
	mutex_.lock();
	++maxcount_;
	count_=maxcount_;
	mutex_.unlock();
	}

midentifier::midentifier(const midentifier &m) 
	{
	count_ = m.count_;
	}

int midentifier::operator==(const midentifier &m) const 
	{
	return (count_ == m.count_);
	}

bool midentifier::operator<(const midentifier &m) const
	{
	return (count_ < m.count_);
	}

midentifier & midentifier::operator=(const midentifier &m) 
	{
	count_ = m.count_;
	return *this;
	}

ostream& operator<<(ostream& str, const midentifier & m) 
	{
//	string daytime(ctime((const time_t *)&m.sec_created_));
//	daytime.resize(daytime.length()-1); // Kill trailing \n
	return (str << "midentifier=" << m.count_);
	}

thread_mutex midentifier::mutex_;
long         midentifier::maxcount_=0;
