// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Mnemonic Object Broker.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef objectbroker_hh__
#define objectbroker_hh__

#include <string>
#include <map.h>

class dlobject;

class object_broker {
   public:
		object_broker(void);
		virtual ~object_broker();
		virtual dlobject  *create_object(const char *oilname,
											const char *create_func, void **ctorArgs);   
		virtual bool       delete_object(void *Object, char *objID);
   private:
		class mnobject {
			public:
				void    *oilhandle;
				int      loadcount;
		};
		map<string,mnobject,less<string> > objects_;
		void *loadoil(const char *oilname);
};

#endif
