
#define DEBUG_CLASS "ref_test"

#include <mnemonic/debug.hh>
#include <mnemonic/debugger.hh>
#include <mnemonic/ptr.hh>
#include <mnemonic/thread.hh>


class A {
public:
	A() {
		cout<<" A\n";
		i=0;
		}

	A(int j) {
		cout<<" A "<<j<<"\n";
		i=j;
  }

  void test1(){
    cout<<"A test "<<i<<"\n";
  }

  virtual void test2(){
    cout<<"A test "<<i<<"\n";
  }
  

  virtual ~A(){
    cout<<" A~ "<<i<<"\n";
  }

  int i;
};

class B:public A {
public:
  B():A() {
    cout<<" B\n";
  }

  B(int j):A(j) {
    cout<<" B "<<j<<"\n";
  }

  void test1(){
    cout<<"B test "<<i<<"\n";
  }

  virtual void test2(){
    cout<<"B test "<<i<<"\n";
  }
  

  virtual ~B(){
    cout<<" B~ "<<i<<"\n";
  }

};

class C:public thread {
public:
  ptr<A> a;
  int stop_;
  C(ptr<A> k){
    a=k;
    cout<<" C "<<a->i<<"\n";cout.flush();
    stop_=0;
  }
  ~C(){
    
    cout<<" C~ "<<a.count()<<"\n";cout.flush();
  }
  void begin(){
    int k;
    cout<<"C b\n";cout.flush();
    for (k=0;k<1000;k++){
      ptr<A> l=a;
      l->i++;
      if (stop_!=0) return;
    }
  }
  void test(){
    cout<<" C "<<a->i<<"\n";cout.flush();
  }
  void cancel(){
		debug("cancel called");
    stop_=1;
  }
};

ptr<A> k;

main(int argc, char **argv)
   {
#ifdef DEBUG
                 int ac=1;
                 while (ac < argc && argv[ac][0] == '-') {
                         switch (argv[ac][1]) {
                         case 'd':
                         case 'D':
                                 debugger::instance().turn_on(argv[ac]+2);
                                 break;
                         }
                         ac++;
                 }
#endif
      cout<<"phase 1\n";
      {
        ptr<A> a(new A(1));
        ptr<A> b;
        ptr<A> c(b);      //construction from empty ptr
        b=b;              //"=" same empty structures
        a=a;              //"=" same filled structures
        a=b;              //"=" put an empty into an filled 
													//A(1) should be gone
        b=c;              //"=" different empty structures 
        a=new A(2);       //"=" contents into ptr
        b=a;              //"=" filled into empty
	a=b;              //"=" filled into "same" filled
        a=c;              
        b=c;              //A(2) should be gone
        a=new A(3);
        ptr<A> d(a);      //construction from filled ptr
        a=c;
        d=c;              //A(3) should be gone
        a=new A(4);
        b=new A(5);
        a=b;              //A(4) should be gone
        c=new A(6);       
                          //a=b=A(5)
                          //c=A(6)
                          //d=0   
      }
      cout<<"phase 2\n";
      {
        ptr<A> a(new A(1));
        ptr<B> b(new B(2));
        a->test1();
        a->test2();
        b->test1();
        b->test2();
        a=b;
        a->test1();
        a->test2();
        b->test1();
        b->test2();       
				ptr<B> c(b);

      }
      cout<<"phase 3\n";
      {
        ptr<A> a=new A(0);
        C *c[10];
debug("1");
				c[0]=new C(a);
debug("1");
        c[1]=new C(a);
debug("1");
				c[0]->a->test1();
debug("1");
        c[0]->a->test2();
debug("1");
        c[0]->start();
debug("1");
				c[1]->start();
debug("1");
				c[0]->test();
debug("1");
debug("1");
				c[0]->test();
debug("1");
//				sleep(2);
 			c[1]->stop();
        c[0]->stop();
      delete c[0];
debug("1");
      delete c[1];
debug("1");
      }
			cout<<"phase 4\n";
			{
				k=new B(1);
				ptr<B> b(k,0);
				
			}
   }
