
#include <string>
#include <iostream.h>
#include <mnemonic/thread.hh>
#include <mnemonic/thread_cond.hh>
#include <mnemonic/debugger.hh>
#include <unistd.h>

class foo_output : public thread {
	public:
		foo_output(const string& str);
		virtual void begin(void);
    virtual void cancel();
	private:
		thread_cond cond_;
static		thread_mutex  mut_;
		string str_;
		int stop_;
};

thread_mutex foo_output::mut_;

void foo_output::cancel(){
  stop_=1;
  cond_.broadcast();
}

foo_output::foo_output(const string& str)
	{
  stop_=0;
	str_=str;
	}

void foo_output::begin(void)
	{
	cond_.lock();
	while(1) {
		mut_.lock();
		cout << str_ << endl;
		mut_.unlock();
		if (stop_) break;
		cond_.wait(1);
		if (stop_) break;
		}
	cond_.unlock();
	}


int main(int, char **)
	{
	foo_output out1("one");
	foo_output out2("two");

	out1.start();
	out2.start();
	sleep(10);
	out1.cancel();
	out2.cancel();
	out1.stop();
	out2.stop();
	
	return 0;
	}
