// -*- mode: C++; c-file-style: "mnemonic"; -*-

#include "curseslayout/cursesboxes.hh"
#include <fstream.h>
#include <stdexcept>
#include <cursesapp.h>
#include <cursesm.h>
#include <cursesf.h>

class testapp : public NCursesApplication {
	public:
		testapp(void);
		int run(void);
};


testapp::testapp(void) : NCursesApplication(TRUE)
	{
	}

int testapp::run(void)
	{
   cursviewer *myviewer=new cursviewer();

	myviewer->refresh();

   curshvbox  *tmppage=new curshvbox(box::horizontal);
   myviewer->add_child(tmppage);

   curshvbox  *tmpbig1=new curshvbox(box::vertical);
   tmppage->add_child(tmpbig1);
   cursbuttonbox *tmppar3d=new cursbuttonbox("testbutton");
	tmpbig1->add_child(tmppar3d); 
   cursparbox *tmppar1=new cursparbox(parbox::horizontal,(float)0.7);
   tmpbig1->add_child(tmppar1);

   curshvbox  *tmpbig2=new curshvbox(box::vertical);
   tmppage->add_child(tmpbig2);
   cursparbox *tmppar2=new cursparbox(parbox::horizontal,(float)0.3);
   tmpbig2->add_child(tmppar2);

   cursglue *tmppar3=new cursglue(stretch_number(),stretch_number(17));
   tmpbig2->add_child(tmppar3);

   cursparbox *tmppar4=new cursparbox(parbox::horizontal,(float)0.3);
   tmpbig2->add_child(tmppar4);
   
   cursbuttonbox *tmppar3e=new cursbuttonbox("Inline");
	tmppar1->add_child(tmppar3e); 

   ifstream str("showoff.txt");
   string tmp;

   while(str >> tmp) { 
		if(tmp=="<pic>") {
			curspreviewbox *tmppic=new curspreviewbox(50,50);
			tmppar1->add_child(tmppic); 
			tmppic=new curspreviewbox(60,30);
			tmppar4->add_child(tmppic);
			}
		else if(tmp=="<but>") {
			cursbuttonbox *tmpbut=new cursbuttonbox("click me\nplease");
			tmppar1->add_child(tmpbut);
			tmpbut=new cursbuttonbox("click me\nplease");
			tmppar4->add_child(tmpbut);
			}
		else {
			curstext_box *tmpbox2=new curstext_box(tmp,&globalstyle);
			tmppar1->add_child(tmpbox2);
			tmpbox2=new curstext_box(tmp,&globalstyle);
			tmppar4->add_child(tmpbox2);
			}
	  cursglue *tmpglue=new cursglue(stretch_number(10),stretch_number());
	  tmppar1->add_child(tmpglue);
	  tmpglue=new cursglue(stretch_number(10),stretch_number());
	  tmppar4->add_child(tmpglue);
	  }
   curstext_box *tmpbox2=new curstext_box("Mnemonic!",&globalstyle2);
   tmppar2->add_child(tmpbox2);

   try { 
	  myviewer->freeze_width(super_number(600));
	  myviewer->freeze_height(super_number(300));
	  myviewer->outside_clip(false);
	  myviewer->show(); // otherwise buttonbox widths are not known
	  cerr << "running" << endl;
	  mymain.run();
	  }
   catch(exception& err) {
	  cerr << "[exception]: " << err.what() << endl;
	  }

	sleep(5);
   delete myviewer;
	return 0;
	}

static testapp demo;


