// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  GTK color related classes.

  Copyright 1999 Kasper Peeters.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef gtkcolors_hh_
#define gtkcolors_hh_

#include <layout/boxes.hh>
#include <layout/colors.hh>
#include <gdk--/colormap.h>

class gtk_colorspec : public layout::color {
	public:
		gtk_colorspec(const string&, Gdk_Colormap&);
		~gtk_colorspec();
		
		Gdk_Color         *color_inf(void) const;
	private:
		mutable Gdk_Color *fg_;
};

class gtk_color_manager : public layout::color_manager {
	public:
		gtk_color_manager(layout::box *owner);
		
		virtual void activate_foreground(layout::color *);
		virtual void activate_background(layout::color *);
	protected:
		virtual layout::color *create_color_impl(const string& name);
	private:
		layout::box *owner_;
};

#endif
