// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  GTK-- layout boxes, interface.

  Copyright 1998-1999 Kasper Peeters.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef gtkfonts_hh_
#define gtkfonts_hh_

#include <string>
#include <layout/boxes.hh>
#include <layout/fonts.hh>
#include <gdk--/font.h>

// external
class gtkbox;

class gtk_fontspec : public layout::font {
	public:
		gtk_fontspec(const layout::xlfd&, bool);
		virtual ~gtk_fontspec();
		
		virtual int32_t string_width(const string&) const;
		virtual int32_t standard_ascent(void) const;
		virtual int32_t standard_descent(void) const;
		virtual int32_t space_width(void) const;

		Gdk_Font& font_inf(void) const;
		int       t1_inf(void) const;
	private:
		mutable Gdk_Font  font_;
		int       t1num_;
};

class gtk_font_manager : public layout::font_manager {
	public:
		gtk_font_manager(layout::box *owner);

		virtual void draw_string(layout::font *, const string& txt, int32_t x, int32_t y);
	protected:
		virtual layout::font *create_font_impl(const layout::xlfd& );
	private:
	   layout::box  *owner_;
		bool          initialised_;
		static bool   t1ok_;
};

#endif
