// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Testprogram for the canvas widgets. Only pops up a window with
  a scrolled canvas in it, does not draw anything. Outputs some
  debugging information upon resizing.

  Copyright 1998-1999 Kasper Peeters.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <gtk--/main.h>
#include <gtk--/window.h>
#include <gdk/gdkrgb.h>

#include <gtklayout/canvaswidgets.hh>

#define DEBUG_CLASS "TESTCANVASWIDGETS"
#include <mnemonic/debug.hh>

int main(int argc, char **argv)
	{
	int ac=1;

	while (ac < argc && argv[ac][0] == '-') {
			switch (argv[ac][1]) {
				case 'h':
					cerr << "Usage: test_canvaswidgets [-dDEBUGCLASS]" << endl;
					exit(1);
#ifdef DEBUG
				case 'd':
					debugger::instance().turn_on(argv[ac]+2);
					break;
#endif
				}
			++ac;
		}


	Gtk::Main mymain(argc, argv);
	gdk_rgb_init();
	gtk_widget_push_visual(gdk_rgb_get_visual());
	gtk_widget_push_colormap(gdk_rgb_get_cmap());

	Gtk::Window mywin;
	mywin.set_events(GDK_EXPOSURE_MASK);
	gtkscrolledcanvas mycanvas;
	mywin.add(mycanvas);
	
	mycanvas.show();
	mywin.show();
	mymain.run();
	}
