
#include <gtk--/main.h>
#include <gtk--/window.h>
#include <gtk--/layout.h>

#include <gdk--/pixmap.h>
#include <gdk--/gc.h>
#include <gdk--/window.h>
#include <gdk--/color.h>

#include <t1lib.h>
#include <t1libx.h>
#include <gdk/gdkx.h>
#include <gdk/gdkrgb.h>

//extern int T1aa_bpp;

#define DEBUG_CLASS "T1TEST"
#include <mnemonic/debug.hh>

class T1_DA : public Gtk::Layout {
	public:
		T1_DA(Gtk::Adjustment&, Gtk::Adjustment&, const string&);
	protected:
		virtual void realize_impl(void);
		virtual gint expose_event_impl(GdkEventExpose *e);
	private:
		Gdk_GC          gc_;
		Gdk_Window      win_;
		Gdk_Pixmap      pix_;
		Gdk_Color       black_, white_;
		int             cmrnum_;
		void draw(void);
		string txt_;
};

T1_DA::T1_DA(Gtk::Adjustment& had, Gtk::Adjustment& vad, const string& txt)
	: Gtk::Layout(had,vad), txt_(txt)
	{
	set_app_paintable(true);
	set_events(GDK_ALL_EVENTS_MASK);	
	
	for(cmrnum_=0; cmrnum_<T1_Get_no_fonts(); ++cmrnum_) {
		if(T1_GetFontFileName(cmrnum_)==string("cmr10.pfb"))
			break;
		}
	if(cmrnum_==T1_Get_no_fonts()) {
		cerr << "sorry, cannot find cmr10 font" << endl;
		exit(1);
		}
	else {
		cerr << "cmr10 is fontID " << cmrnum_ << endl;
		}
	}

void T1_DA::realize_impl(void)
	{
	Gtk::Layout::realize_impl();
	cout << "realize " << width() << "," << height() << endl;
	win_=gtkobj()->bin_window;
	T1_SetX11Params(GDK_COLORMAP_XDISPLAY( gdk_rgb_get_cmap() ),
						 GDK_VISUAL_XVISUAL(	gdk_rgb_get_visual() ),
						 gdk_visual_get_best_depth(),
						 GDK_COLORMAP_XCOLORMAP( get_colormap().gdkobj() )
						 );

/*	static unsigned long grayvals[] = { 1, 1, 1, 1,
												 1, 1, 1, 1,
												 1, 1, 1, 1,
												 1, 1, 1, 1,
												 1 }; */
	T1_AASetBitsPerPixel(gdk_visual_get_best_depth());
	T1_AASetLevel(T1_AA_HIGH);
//	T1_AAHSetGrayValues(grayvals);

	gc_=Gdk_GC(win_);
	white_=Gdk_Color("white");
	black_=Gdk_Color("black");
	get_colormap().alloc(white_);
	get_colormap().alloc(black_);
	}

gint T1_DA::expose_event_impl(GdkEventExpose *e)
	{
	draw();
	return Gtk::Layout::expose_event_impl(e);
	}

void T1_DA::draw(void)
	{
	cout << "drawing" << endl;
	pix_=Gdk_Pixmap(win_,width(), height());
	gc_.set_foreground(white_);
	pix_.draw_rectangle(gc_,TRUE,0,0,width(),height());
	gc_.set_foreground(black_);
	gc_.set_background(white_);
	cout << "text" << endl;
	GLYPH *fik=T1_AASetStringX(GDK_WINDOW_XWINDOW(pix_.gdkobj()), GDK_GC_XGC(gc_.gdkobj()), 
										0,      // mode
										0, 100, // coordinates
										cmrnum_,      // font id
										"Something special is happening", 0, // string
										0,      // spaceoff
										0,      // kerning
										15.0,   // size
										NULL    // transform matrix
										); 
	cout << "set_back_pixmap" << endl;
	win_.set_back_pixmap(pix_,false);
	win_.clear_area(0,0,width(),height());
	cout << fik << endl;
	}

int main(int argc, char **argv)
	{
	if ((T1_InitLib(NO_LOGFILE)==NULL)) {
		cout << "sorry, failed to init T1lib" << endl;
		exit(1);
		}

/*	for(int fi=0; fi<T1_Get_no_fonts(); ++fi) {
		cout << T1_GetFontFileName(fi) << endl;
		} */

	Gtk::Main mymain(argc, argv);
	gdk_rgb_set_install(true);//false);
	gdk_rgb_set_min_colors(2*2*2);
	gdk_rgb_set_verbose(true);
	gdk_rgb_init();
	gtk_widget_push_visual(gdk_rgb_get_visual());
	gtk_widget_push_colormap(gdk_rgb_get_cmap());

	Gtk::Window mywindow;
	Gtk::Adjustment hadj(0,0,20,8,8,5);
	Gtk::Adjustment vadj(0,0,20,8,8,5);
	T1_DA      myarea(hadj, vadj, "hi");
	mywindow.add(myarea);
	
	mywindow.show_all();
	mymain.run();
	}
