// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Color related classes.

  Copyright 1999 Kasper Peeters.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef colors_hh_
#define colors_hh_

#include <string>
#include <map.h>

namespace layout {

 // classes defined here 
 class color;
 class color_manager;

 class color_manager {
	 public:
		 color_manager(void);
		 virtual ~color_manager();
		 
		 virtual color *get_color(const string& name);
		 virtual void   activate_foreground(color *)=0;
		 virtual void   activate_background(color *)=0;
	 protected:
		 virtual color *create_color_impl(const string& name)=0;
		 const color   *active_fg_color_;
		 const color   *active_bg_color_;
	 private:
		 map<string, color *>  colors_;
 };

 class color {
	 public:
		 color(const string& name);
		 
		 string name(void) const;
	 protected:
		string             colorname_;
 };

};

#endif
