// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Output device independent layout algorithms, interface.

  Copyright 1999 Kasper Peeters.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef factory_hh_
#define factory_hh_

#include <layout/boxes.hh>
#include <layout/interactive.hh>

namespace layout {

 class factory {
	 public:
		 virtual viewer_box     *create_viewer_box(void);

		 virtual glue           *create_glue(void);
		 virtual text_box       *create_text_box(const string&);
		 virtual property_box   *create_property_box(property_box *inherit, font *, color *, color *);
		 virtual table          *create_table(void);
		 virtual hbox           *create_hbox(void);
		 virtual vbox           *create_vbox(void);
		 virtual border_box     *create_border_box(void);
		 virtual parbox         *create_parbox(void);
		 virtual event_box      *create_event_box(void);

		 virtual button_box     *create_button_box(void);
/*		 virtual text_entry_box *create_text_entry_box(void);
		 virtual list_box       *create_list_box(void);
		 virtual radio_box      *create_radio_box(void);
		 virtual combo_box      *create_combo_box(void); */
 };

};


#endif
