
#include <string>
#include <layout/colors.hh>
#include <stdexcept>

#define DEBUG_CLASS "COLORS"
#include <mnemonic/debug.hh>

using namespace layout;

color_manager::color_manager(void)
	: active_fg_color_(0), active_bg_color_(0)
	{
	}

color_manager::~color_manager()
	{
	map<string, color *>::iterator it=colors_.begin();
	while(it!=colors_.end()) {
		delete (*it).second;
		++it;
		}
	}

color *color_manager::get_color(const string& name)
	{
	debug("color_manager::get_color");
	map<string, color *>::iterator it=colors_.find(name);
	debug("found?");
	if(it!=colors_.end()) {
		debug("color " << name << " reused");
		return (*it).second;
		}
	else {
		color *tmp=create_color_impl(name);
		if(tmp==0) {
			debug("color " << name << " does not exist");
			throw logic_error(string("color ")+name+string(" does not exist"));
			}
		debug("color " << name << " newly created");
		colors_[name]=tmp;
		return tmp;
		}
	}

color::color(const string& name)
	: colorname_(name)
	{
	}

string color::name(void) const
	{
	return colorname_;
	}
