
#include "mathrender/mathrenderer.hh"

const mathrenderer::entity_pair mathrenderer::mathml_entities_[] = {
	{ "Afr",               0xf78a },
	{ "Agr",               0x0391 },
	{ "AlignmentMarker",   0xfffd },
   { "Alpha",             0x0391 },
   { "Angle",             0x0220 },
   { "Aopf",              0xf7a4 },
   { "ApplyFunction",     0xfffd },
   { "Ascr",              0xf770 },
   { "BadBreak",          0xfffd },
   { "Beta",              0x0392 },
   { "Bfr",               0xf78b },
   { "Bgr",               0x0392 },
   { "Bopf",              0xf7a5 },
   { "Box",               0x25a1 },
   { "Bscr",              0xf771 },
   { "Bullet",            0x2022 },
   { "CapitalAlpha",      0x0391 },
   { "CapitalBeta",       0x0392 },
   { "CapitalChi",        0x03a7 },
   { "CapitalDelta",      0x0394 },
   { "CapitalDifferentialD", 0x0034 },
   { "CapitalEpsilon",    0x0395 },
   { "CapitalEta",        0x0397 },
   { "CapitalGamma",      0x0393 },
   { "CapitalIota",       0x0399 },
   { "CapitalKappa",      0x039a },
   { "CapitalLambda",     0x039b },
   { "CapitalMu",         0x039c },
   { "CapitalNu",         0x039d },
   { "CapitalOmega",      0x03a9 },
   { "CapitalOmicron",    0x039f },
   { "CapitalPhi",        0x03a6 },
   { "CapitalPi",         0x03a0 },
   { "CapitalPsi",        0x03a8 },
   { "CapitalRho",        0x03a1 },
   { "CapitalSigma",      0x03a3 },
   { "CapitalTau",        0x03a4 },
   { "CapitalTheta",      0x0398 },
   { "CapitalUpsilon",    0x03a5 },
   { "CapitalXi",         0x039e },
   { "CapitalZeta",       0x0396 },
   { "CenterDot",         0x00b7 },
   { "CenterEllipsis",    0x22ef },
   { "Cfr",               0xf78c },
   { "Chi",               0x03a7 },
   { "CirclePlus",        0x2295 },
   { "CircleTimes",       0x2297 },
   { "Congruent",         0x2261 },
   { "Continuation",      0x22f1 },
   { "ContourIntegral",   0x222e },
   { "Copf",              0xf7a6 },
   { "Coproduct",         0x2210 },
   { "Cscr",              0xf772 },
   { "CurlyEpsilon",      0x03b5 },
   { "DD",                0x0044 },
   { "Dash",              0x2013 },
   { "Del",               0x2207 },
   { "Delta",             0x0394 },
   { "Dfr",               0xf78d },
   { "Dgr",               0x0394 },
   { "DiacriticalTilde",  0x0303 },
   { "DifferentialD",     0x0044 },
   { "Divide",            0x00f7 },
   { "Dopf",              0xf7a7 },
   { "DoubleDot",         0x0308 },
   { "DoubleDownArrow",   0x21d3 },
   { "DoubleLeftArrow",   0x21d0 },
   { "DoubleLeftRightArrow", 0x21d4 },
   { "DoubleRightArrow",  0x21d2 },
   { "DoubleUpArrow",     0x21d1 },
   { "DoubleUpDownArrow", 0x21d5 },
   { "DoubleVerticalBar", 0x2225 },
   { "DownArrow",         0x2193 },
   { "DownTee",           0x22a4 },
   { "Downarrow",         0x21d3 },
   { "Dscr",              0xf773 },
   { "EEgr",              0x0397 },
   { "Efr",               0xf78e },
   { "Egr",               0x0395 },
   { "Element",           0x2208 },
   { "Ellipsis",          0x2026 },
   { "Empty",             0x2205 },
   { "EmptyDownTriangle", 0x25bd },
   { "EmptySet",          0x2205 },
   { "EmptyUpTriangle",   0x25b3 },
   { "Eopf",              0xf7a8 },
   { "Epsilon",           0x0395 },
   { "Escr",              0xf774 },
   { "Eta",               0x0397 },
   { "Exists",            0x2203 },
   { "ExponentialE",      0x0065 },
   { "Ffr",               0xf78f },
   { "Fgr",               0x03a6 },
   { "FilledRectangle",   0x25a0 },
   { "Fopf",              0xf7a9 },
   { "ForAll",            0x2200 },
   { "Fscr",              0xf775 },
   { "Gamma",             0x0393 },
   { "Gfr",               0xf790 },
   { "Ggr",               0x0393 },
   { "GoodBreak",         0xfffd },
   { "Gopf",              0xf7aa },
   { "GreaterEqual",      0x2265 },
   { "GreaterGreater",    0x226b },
   { "Gscr",              0xf776 },
   { "Gt",                0x226b },
   { "HBar",              0x210f },
   { "Hacek",             0x030c },
   { "Hfr",               0xf791 },
   { "Hopf",              0xf7ab },
   { "Hscr",              0xf777 },
   { "Ifr",               0xf792 },
   { "Im",                0xf792 },
   { "ImaginaryI",        0x0069 },
   { "IndentingNewLine",  0xfffd },
   { "Infinity",          0x221e },
   { "Int",               0x222c },
   { "Integral",          0x222b },
   { "InvisibleComma",    0xfffd },
   { "InvisibleTimes",    0xf362 },
   { "Iopf",              0xf7ac },
   { "Iota",              0x0399 },
   { "Iscr",              0xf778 },
   { "Jfr",               0xf793 },
   { "Jopf",              0xf7ad },
   { "Jscr",              0xf779 },
   { "KHgr",              0x03a7 },
   { "Kappa",             0x039a },
   { "Kfr",               0xf794 },
   { "Kgr",               0x039a },
   { "Kopf",              0xf7ae },
   { "Kscr",              0xf77a },
   { "Lambda",            0x039b },
   { "LeftAngleBracket",  0x2329 },
   { "LeftArrow",         0x2190 },
   { "LeftCeiling",       0x2308 },
   { "LeftFloor",         0x230a },
   { "LeftRightArrow",    0x2194 },
   { "Leftarrow",         0x21d0 },
   { "Leftrightarrow",    0x21d4 },
   { "LessEqual",         0x2264 },
   { "LessLess",          0x226a },
   { "Lfr",               0xf795 },
   { "Lgr",               0x039b },
   { "Longleftrightarrow",0xF502 },
   { "Lopf",              0xf7af },
   { "LowerLeftArrow",    0x2199 },
   { "LowerRightArrow",   0x2198 },
   { "Lscr",              0xf77b },
   { "Lt",                0x226a },
   { "MediumSpace",       0xf364 },
   { "Mfr",               0xf796 },
   { "Mgr",               0x039c },
   { "MissingTerm",       0xfffd },
   { "Mopf",              0xf7b0 },
   { "Mscr",              0xf77c },
   { "Mu",                0x039c },
   { "NegativeMediumSpace", 0xf383 },
   { "NegativeThickSpace",0xf384 },
   { "NegativeThinSpace", 0xf382 },
   { "NegativeVeryThinSpace", 0xf380 },
   { "NewLine",           0xfffd },
   { "Nfr",               0xf797 },
   { "NoBreak",           0xfffd },
   { "NonBreakingSpace",  0xf363 },
   { "Nopf",              0xf7b1 },
   { "Not",               0x00ac },
   { "NotDoubleVerticalBar", 0x2226 },
   { "NotElement",        0x2209 },
   { "NotEqual",          0x2260 },
   { "NotExists",         0x2204 },
   { "NotGreater",        0x226f },
   { "NotGreaterSlantEqual", 0x2271 },
   { "NotLess",           0x226e },
   { "NotLessSlantEqual", 0x2270 },
   { "NotSubset",         0x2284 },
   { "NotSubsetEqual",    0x2288 },
   { "NotSuperset",       0x2285 },
   { "NotSupersetEqual",  0x2289 },
   { "NotTildeFullEqual", 0x2247 },
   { "NotVerticalBar",    0x2224 },
   { "Nscr",              0xf77d },
   { "Nu",                0x039d },
   { "OHgr",              0x03a9 },
   { "Ofr",               0xf798 },
   { "Omega",             0x03a9 },
   { "Omicron",           0x039f },
   { "Oopf",              0xf7b2 },
   { "Oscr",              0xf77e },
   { "OverBar",           0x0304 },
   { "OverBrace",         0xf612 },
   { "OverLine",          0x0304 },
   { "PSgr",              0x03a8 },
   { "PartialD",          0x2202 },
   { "Pfr",               0xf799 },
   { "Pgr",               0x03a0 },
   { "Phi",               0x03a6 },
   { "Pi",                0x03a0 },
   { "PlusMinus",         0x00b1 },
   { "Popf",              0xf7b3 },
   { "Prime",             0x2032 },
   { "Product",           0x220f },
   { "Proportional",      0x221d },
   { "Pscr",              0xf77f },
   { "Psi",               0x03a8 },
   { "Qfr",               0xf79a },
   { "Qopf",              0xf7b4 },
   { "Qscr",              0xf780 },
   { "Re",                0xf79b },
   { "ReverseElement",    0x220b },
   { "Rfr",               0xf79b },
   { "Rgr",               0x03a1 },
   { "Rho",               0x03a1 },
   { "RightAngleBracket", 0x232a },
   { "RightArrow",        0x2192 },
   { "RightCeiling",      0x2309 },
   { "RightFloor",        0x230b },
   { "RightTeeArrow",     0x21a6 },
   { "RightVector",       0x21c0 },
   { "Rightarrow",        0x21d2 },
   { "Ropf",              0xf7b5 },
   { "Rscr",              0xf781 },
   { "Sfr",               0xf79c },
   { "Sgr",               0x03a3 },
   { "Sigma",             0x03a3 },
   { "SmallCircle",       0x2218 },
   { "Sopf",              0xf7b6 },
   { "Space",             0xf363 },
   { "Sqrt",              0x221a },
   { "Sscr",              0xf782 },
   { "Subset",            0x2282 },
   { "SubsetEqual",       0x2286 },
   { "Sum",               0x2211 },
   { "Superset",          0x2283 },
   { "SupersetEqual",     0x2287 },
   { "THgr",              0x0398 },
   { "Tau",               0x03a4 },
   { "Tfr",               0xf79d },
   { "Tgr",               0x03a4 },
   { "Theta",             0x0398 },
   { "ThickSpace",        0xf365 },
   { "ThinSpace",         0xf363 },
   { "Tilde",             0x223c },
   { "TildeEqual",        0x2243 },
   { "TildeFullEqual",    0x2245 },
   { "TildeTilde",        0x2248 },
   { "Times",             0x00d7 },
   { "Topf",              0xf7b7 },
   { "Tscr",              0xf783 },
   { "Ufr",               0xf79e },
   { "Ugr",               0x03a5 },
   { "UnderBrace",        0xf613 },
   { "Uopf",              0xf7b8 },
   { "UpArrow",           0x2191 },
   { "UpDownArrow",       0x2195 },
   { "UpTee",             0x22a5 },
   { "Uparrow",           0x21d1 },
   { "Updownarrow",       0x21d5 },
   { "UpperLeftArrow",    0x2196 },
   { "UpperRightArrow",   0x2197 },
   { "Upsilon",           0x03a5 },
   { "Uscr",              0xf784 },
   { "VecLap",            0xee26 },
   { "Verbar",            0x2016 },
   { "Vert",              0x2016 },
   { "VerticalBar",       0x2223 },
   { "VerticalEllipsis",  0x22ee },
   { "VeryThinSpace",     0xf362 },
   { "Vfr",               0xf79f },
   { "Vopf",              0xf7b9 },
   { "Vscr",              0xf785 },
   { "Wfr",               0xf7a0 },
   { "Wopf",              0xf7ba },
   { "Wscr",              0xf786 },
   { "Xfr",               0xf7a1 },
   { "Xi",                0x039e },
   { "Xopf",              0xf7bb },
   { "Xscr",              0xf787 },
   { "Yfr",               0xf7a2 },
   { "Ygr",               0x039e },
   { "Yopf",              0xf7bc },
   { "Yscr",              0xf788 },
   { "ZeroWidthSpace",    0xfffd },
   { "Zeta",              0x0396 },
   { "Zfr",               0xf7a3 },
   { "Zgr",               0x0396 },
   { "Zopf",              0xf7bd },
   { "Zscr",              0xf789 },
   { "af",                0xfffd },
   { "afr",               0xf6cc },
   { "agr",               0x03b1 },
   { "aleph",             0x2135 },
   { "alpha",             0x03b1 },
   { "amalg",             0xe251 },
   { "ang",               0x2220 },
   { "angle",             0x2220 },
   { "angupr",            0x2220 },
   { "ap",                0x2248 },
   { "approx",            0x2248 },
   { "backslash",         0x2216 },
   { "bar",               0x0304 },
   { "bbull",             0x2022 },
   { "because",           0x2235 },
   { "beta",              0x03b2 },
   { "bfr",               0xf6cd },
   { "bgr",               0x03b2 },
   { "bigcap",            0x22c2 },
   { "bigcoprod",         0xee18 },
   { "bigcup",            0x22c3 },
   { "bigiiint",          0xee22 },
   { "bigiint",           0xee21 },
   { "bigint",            0xee07 },
   { "bigoint",           0xee08 },
   { "bigoplus",          0xee0a },
   { "bigotimes",         0xee09 },
   { "bigprod",           0xee06 },
   { "bigsum",            0xee05 },
   { "bigtriangledown",   0x25bd },
   { "bigtriangleup",     0x25b3 },
   { "bigwedge",          0x22c0 },
   { "blacksquare",       0x25a0 },
   { "bot",               0x22a5 },
   { "bottom",            0x22a5 },
   { "bull",              0x2022 },
   { "bullet",            0x2022 },
   { "bulop",             0x2218 },
   { "cap",               0x2229 },
   { "caret",             0x0302 },
   { "caron",             0x030c },
   { "cdot",              0x00b7 },
   { "cdotp",             0x00b7 },
   { "cdots",             0x22ef },
   { "ceill",             0x2308 },
   { "ceilr",             0x2309 },
   { "cellip",            0x22ef },
   { "centerdot",         0x00b7 },
   { "cfr",               0xf6ce },
   { "check",             0x030c },
   { "chi",               0x03c7 },
   { "circ",              0x2218 },
   { "clb",               0xf613 },
   { "compfn",            0x2218 },
   { "cong",              0x2245 },
   { "conint",            0x222e },
   { "convolu",           0x2218 },
   { "coprod",            0x2210 },
   { "ctdot",             0x22ef },
   { "cub",               0xf612 },
   { "cup",               0x222a },
   { "d9",                0x030c },
   { "dArr",              0x21d3 },
   { "darr",              0x2193 },
   { "dd",                0x0044 },
   { "ddot",              0x0308 },
   { "ddots",             0x22f1 },
   { "delta",             0x03b4 },
   { "dfr",               0xf6cf },
   { "dgr",               0x03b4 },
   { "die",               0x0308 },
   { "div",               0x00f7 },
   { "divide",            0x00f7 },
   { "dlarr",             0x2199 },
   { "dot",               0x0307 },
   { "dots",              0x2026 },
   { "downarrow",         0x2193 },
   { "drarr",             0x2198 },
   { "dtdot",             0x22f1 },
   { "dtri",              0x25bd },
   { "ee",                0x0065 },
   { "eegr",              0x03b7 },
   { "efr",               0xf6d0 },
   { "egr",               0x220a },
   { "elipd",             0x22ee },
   { "ell",               0xf6bd },
   { "ellip",             0x2026 },
   { "emptyset",          0x2205 },
   { "emptyv",            0x2205 },
   { "endash",            0x2013 },
   { "epsi",              0x220a },
   { "epsilon",           0x220a },
   { "epsiv",             0x03b5 },
   { "equals",            '=' },
   { "equiv",             0x2261 },
   { "eta",               0x03b7 },
   { "exist",             0x2203 },
   { "exists",            0x2203 },
   { "ffr",               0xf6d1 },
   { "fgr",               0x03c6 },
   { "flat",              0x266d },
   { "floorl",            0x230a },
   { "floorr",            0x230b },
   { "forall",            0x2200 },
   { "gE",                0x2265 },
   { "gamma",             0x03b3 },
   { "ge",                0x2265 },
   { "geq",               0x2265 },
   { "gfr",               0xf6d2 },
   { "gg",                0x226b },
   { "ggr",               0x03b3 },
   { "greater",           0x003e },
   { "gt",                0x003e },
   { "hArr",              0x21d4 },
   { "hacek",             0x030c },
   { "harr",              0x2194 },
   { "hat",               0x0302 },
   { "hbar",              0x210f },
   { "hellip",            0x2026 },
   { "hfr",               0xf6d3 },
   { "hkarrow",           0x21aa },
   { "hookleftarrow",     0x21a9 },
   { "hookrightarrow",    0x21aa },
   { "hslash",            0x210f },
   { "ic",                0xfffd },
   { "iff",               0xF502 },
   { "ifr",               0xf6d4 },
   { "ii",                0x0069 },
   { "iiint",             0x222d },
   { "iint",              0x222c },
   { "imath",             0xf730 },
   { "implies",           0x21d2 },
   { "in",                0x2208 },
   { "infin",             0x221e },
   { "infty",             0x221e },
   { "int",               0x222b },
   { "iota",              0x03b9 },
   { "isin",              0x2208 },
   { "isinv",             0x2208 },
   { "it",                0xf362 },
   { "jfr",               0xf6d5 },
   { "jmath",             0xf731 },
   { "kappa",             0x03ba },
   { "kfr",               0xf6d6 },
   { "kgr",               0x03ba },
   { "khgr",              0x03c7 },
   { "lArr",              0x21d0 },
   { "lE",                0x2264 },
   { "lambda",            0x03bb },
   { "lang",              0x2329 },
   { "langle",            0x2329 },
   { "larr",              0x2190 },
   { "larrhk",            0x21a9 },
   { "lbrace",            0x007b },
   { "lbrack",            0x005b },
   { "lbrak",             0x005b },
   { "lceil",             0x2308 },
   { "lcub",              0x007b },
   { "ldots",             0x2026 },
   { "le",                0x2264 },
   { "leftarrow",         0x2190 },
   { "leftrightarrow",    0x2194 },
   { "leq",               0x2264 },
   { "less",              0x003c },
   { "lfloor",            0x230a },
   { "lfr",               0xf6d7 },
   { "lgr",               0x03bb },
   { "ll",                0x226a },
   { "llarrow",           0xf51c },
   { "longleftarrow",     0xf51c },
   { "longrightarrow",    0xf51d },
   { "lpar",              0x0028 },
   { "lparen",            0x0028 },
   { "lrarrow",           0xf51d },
   { "lsqb",              0x005b },
   { "lt",                0x003c },
   { "ltimes",            0x22c9 },
   { "macr",              0x0304 },
   { "map",               0x21a6 },
   { "mapr",              0x21a6 },
   { "mapsto",            0x21a6 },
   { "medsp",             0xf363 },
   { "mfr",               0xf6d8 },
   { "mgr",               0x03bc },
   { "mid",               0x2223 },
   { "middot",            0x00b7 },
   { "mu",                0x03bc },
   { "nabla",             0x2207 },
   { "natural",           0x266e },
   { "nbsp",              0xf363 },
   { "ncong",             0x2247 },
   { "ndash",             0x2013 },
   { "ne",                0x2260 },
   { "nearr",             0x2197 },
   { "nearrow",           0x2197 },
   { "neg",               0x00ac },
   { "negsp",             0xf382 },
   { "neq",               0x2260 },
   { "nexist",            0x2204 },
   { "nexists",           0x2204 },
   { "nfr",               0xf6d9 },
   { "ngeq",              0x2271 },
   { "ngeqslant",         0x2271 },
   { "nges",              0x2271 },
   { "ngt",               0x226f },
   { "ngtr",              0x226f },
   { "ni",                0x220b },
   { "niv",               0x220b },
   { "nleq",              0x2270 },
   { "nleqslant",         0x2270 },
   { "nles",              0x2270 },
   { "nless",             0x226e },
   { "nlt",               0x226e },
   { "nmid",              0x2224 },
   { "nonit",             0x2209 },
   { "not",               0x00ac },
   { "notin",             0x2209 },
   { "npar",              0x2226 },
   { "nparallel",         0x2226 },
   { "npr",               0x2280 },
   { "nprec",             0x2280 },
   { "npreceq",           0x22e0 },
   { "nsc",               0x2281 },
   { "nsub",              0x2284 },
   { "nsube",             0x2288 },
   { "nsubset",           0x2284 },
   { "nsubseteq",         0x2288 },
   { "nsucc",             0x2281 },
   { "nsucceq",           0x22e1 },
   { "nsup",              0x2285 },
   { "nsupe",             0x2289 },
   { "nsupset",           0x2285 },
   { "nsupseteq",         0x2289 },
   { "nu",                0x03bd },
   { "nullset",           0x2205 },
   { "nwarr",             0x2196 },
   { "nwarrow",           0x2196 },
   { "ofr",               0xf6da },
   { "ohgr",              0x03c9 },
   { "oint",              0x222e },
   { "omega",             0x03c9 },
   { "omicron",           0x03bf },
   { "oplus",             0x2295 },
   { "otimes",            0x2297 },
   { "ovrcub",            0xf612 },
   { "par",               0x2225 },
   { "parallel",          0x2225 },
   { "part",              0x2202 },
   { "partial",           0x2202 },
   { "perp",              0x22a5 },
   { "pfr",               0xf6db },
   { "pgr",               0x03c0 },
   { "phgr",              0x03c6 },
   { "phi",               0x03c6 },
   { "pi",                0x03c0 },
   { "planck",            0x210f },
   { "plankv",            0x210f },
   { "plus",              0x002b },
   { "plusmn",            0x00b1 },
   { "pm",                0x00b1 },
   { "pr",                0x227a },
   { "prcue",             0x227c },
   { "preceq",            0x227c },
   { "prime",             0x2032 },
   { "prod",              0x220f },
   { "prop",              0x221d },
   { "propto",            0x221d },
   { "psgr",              0x03c8 },
   { "psi",               0x03c8 },
   { "qed",               0x25a0 },
   { "qfr",               0xf6dc },
   { "quad",              0xf365 },
   { "rArr",              0x21d2 },
   { "radic",             0x221a },
   { "rang",              0x232a },
   { "rangle",            0x232a },
   { "rarr",              0x2192 },
   { "rarrd",             0x2198 },
   { "rarrhk",            0x21aa },
   { "rbrace",            0x007d },
   { "rbrack",            0x005d },
   { "rbrak",             0x005d },
   { "rceil",             0x2309 },
   { "rcub",              0x007d },
   { "rfloor",            0x230b },
   { "rfr",               0xf6dd },
   { "rgr",               0x03c1 },
   { "rharu",             0x21c0 },
   { "rho",               0x03c1 },
   { "rightarrow",        0x2192 },
   { "rightharpoonup",    0x21c0 },
   { "rpar",              0x0029 },
   { "rparen",            0x0029 },
   { "rsqb",              0x005d },
   { "rtimes",            0x22ca },
   { "sc",                0x227b },
   { "sccue",             0x227d },
   { "searr",             0x2198 },
   { "searrow",           0x2198 },
   { "setminus",          0x2216 },
   { "sfr",               0xf6de },
   { "sgr",               0x03c3 },
   { "sharp",             0x266f },
   { "sigma",             0x03c3 },
   { "sim",               0x223c },
   { "sime",              0x2243 },
   { "simeq",             0x2243 },
   { "smallsetminus",     0xee10 },
   { "soldotr",           0x22f1 },
   { "sqrt",              0x221a },
   { "squ",               0x25a1 },
   { "square",            0x25a1 },
   { "sub",               0x2282 },
   { "subNe",             0x2288 },
   { "sube",              0x2286 },
   { "sublineh",          0x2284 },
   { "subset",            0x2282 },
   { "subseteq",          0x2286 },
   { "subuline",          0x2286 },
   { "succ",              0x227b },
   { "succeq",            0x227d },
   { "sum",               0x2211 },
   { "sup",               0x2283 },
   { "supNe",             0x2289 },
   { "supe",              0x2287 },
   { "suplineh",          0x2285 },
   { "supset",            0x2283 },
   { "supseteq",          0x2287 },
   { "supuline",          0x2287 },
   { "surd",              0x221a },
   { "swarr",             0x2199 },
   { "swarrow",           0x2199 },
   { "tau",               0x03c4 },
   { "tfr",               0xf6df },
   { "tgr",               0x03c4 },
   { "therefore",         0x2234 },
   { "theta",             0x03b8 },
   { "thgr",              0x03b8 },
   { "thicksp",           0xf364 },
   { "thinsp",            0xf362 },
   { "tilde",             0x0303 },
   { "times",             0x00d7 },
   { "tint",              0x222d },
   { "to",                0x2192 },
   { "top",               0x22a4 },
   { "triangleleft",      0x22b2 },
   { "triangleright",     0x22b3 },
   { "uArr",              0x21d1 },
   { "uarr",              0x2191 },
   { "udrcub",            0xf613 },
   { "ufr",               0xf6e0 },
   { "ugr",               0x03c5 },
   { "uparrow",           0x2191 },
   { "updownarrow",       0x2195 },
   { "upsi",              0x03c5 },
   { "upsilon",           0x03c5 },
   { "urcorn",            0x00ac },
   { "utri",              0x25b3 },
   { "vArr",              0x21d5 },
   { "varepsilon",        0x03b5 },
   { "varnothing",        0x2205 },
   { "varphi",            0x03d5 },
   { "varpi",             0x03d6 },
   { "varr",              0x2195 },
   { "varrho",            0x03f1 },
   { "vartheta",          0x03d1 },
   { "vdots",             0x22ee },
   { "vec",               0x21c0 },
   { "vee",               0x2228 },
   { "vellip",            0x22ee },
   { "verbar",            0x2223 },
   { "vert",              0x2223 },
   { "vfr",               0xf6e1 },
   { "vnsub",             0x2284 },
   { "vnsup",             0x2285 },
   { "wedge",             0x2227 },
   { "wfr",               0xf6e2 },
   { "wp",                0x2118 },
   { "xdtri",             0x25bd },
   { "xfr",               0xf6e3 },
   { "xgr",               0x03be },
   { "xhArr",             0xF502 },
   { "xi",                0x03be },
   { "xlarr",             0xf51c },
   { "xrarr",             0xf51d },
   { "xutri",             0x25b3 },
   { "yfr",               0xf6e4 },
   { "zeta",              0x03b6 },
   { "zfr",               0xf6e5 },
   { "zgr",               0x03b6 },
   { "{",                 0x007b },
   { "|",                 0x2016 },
   { "}",                 0x007d } };
