#ifndef SSLEAYDEFSH
#define SSLEAYDEFSH

/* **************************************************************** */
/* This file will be used to hold all of the peculiar SSLeay def's  */
/* that are necessary for this project.                             */
/* **************************************************************** */

#define USE_SOCKETS
#ifdef NO_STDIO
#define APPS_WIN16
#endif

#include <unistd.h>

#ifdef WIN16
#define SOCKET_PROTOCOL 0 /* more microsoft stupidity */
#else
#define SOCKET_PROTOCOL IPPROTO_TCP
#endif

#ifdef WINDOWS
#define get_last_socket_error() WSAGetLastError()
#define clear_socket_error()    WSASetLastError(0)
#else
#define get_last_socket_error() errno
#define clear_socket_error()    errno=0
#define ioctlsocket(a,b,c)      ioctl(a,b,c)
#endif

#define SHUTDOWN(fd)    { shutdown((fd),0); close((fd)); }

#include <signal.h>

#ifdef SIGPIPE
#define do_pipe_sig()   signal(SIGPIPE,SIG_IGN)
#else
#define do_pipe_sig()
#endif


#if defined(MONOLITH) && !defined(SSLEAY)
#  define apps_startup()        do_pipe_sig()
#else
#  if defined(MSDOS) || defined(WIN16) || defined(WIN32)
#    ifdef _O_BINARY
#      define apps_startup() \
                _fmode=_O_BINARY; do_pipe_sig(); CRYPTO_malloc_init(); \
                SSLeay_add_all_algorithms()
#    else
#      define apps_startup() \
                _fmode=O_BINARY; do_pipe_sig(); CRYPTO_malloc_init(); \
                SSLeay_add_all_algorithms()
#    endif
#  else
#    define apps_startup()      do_pipe_sig(); SSLeay_add_all_algorithms();
#  endif
#endif

#include <ssl.h>
#include <pem.h>

#define PORT 443

#define BUFSIZZ 1024



#endif // SSLEAYDEFSH Defined
