#include <iostream>
#include <tcpcon/tcp_connection.hh>
#include <mnemonic/objectmanager.hh>

#include <mnemonic/debug.hh>

int main(int argc, char *argv[])
	{
#ifdef DEBUG
	debugger::instance().turn_on("ALL");
#endif

	if(argc < 3) {
		cerr << "Hmmm, no host or port number to try" << endl
			<< "Usage:  test_tcp host port" << endl;
		return 1;
		}
	int port_num = atoi(argv[2]);
	if(port_num == 0) {
		cerr << "Port number evaluates to zero - please fix" << endl;
		}
	object_manager::instance().load_interests();
	tcp_connection *tmp=new tcp_connection(string(argv[1]), port_num);
	if(tmp->lookup() == -1) {
		cerr << "TCP lookup error: " << tmp->error_text() << endl;
		return 2;
		}
	if(tmp->connect() == -1) {
		cerr << "TCP connection error: " << tmp->error_text() << endl;
		return 3;
		}
	if(tmp->status() != tcp_connection::ok) {
		cerr << "TCP connection status is not okay: " << tmp->error_text()
			<< endl;
		return 4;
		}
	cout << "Writing junk to port :-)" << endl;
	tmp->write("junk\n\n", 6);
	char read_buff[200];
	ssize_t bytes_read;
	while((bytes_read = tmp->read(read_buff, 199)) > 0) {
		read_buff[bytes_read] = '\0';
		cout << read_buff;
		}
	delete tmp;

	return 0;
	}

