#ifndef tex_parser_hh_
#define tex_parser_hh_

#include <string>
#include <map.h>
#include <vector.h>

#include <mnemonic/ptr.hh>
#include <texdoc/document.hh>

namespace tex {

 class parser {
	 public:
		 parser(ptr<tex::document>);

		 void append_data(int length, const char *data);
		 friend istream& operator>>(istream& str, parser&);
		 
	 protected:
		 string  raw_data_;          // FIXME: replace with `rope' when they removed the warnings in stl_rope.h
		 unsigned long  offset_in_stream_;    // The place where raw_data[0] is located in the stream.
		 unsigned long  lines_in_stream_;     // How many lines were spotted before offset_in_stream.
		 
		 string                   accumulator_;
		 string                   tagname_;
		 string                   key_,val_;
		 map<string,string>       keyvalpairs_;
		 
		 enum parse_state { INITIAL };
		 
		 class history_element {
			 public:
				 history_element(parse_state, long, long);
				 
				 parse_state state;
				 unsigned long        offset_in_stream;
				 unsigned long        line_in_stream;
		 };
		 
		 vector<history_element>  parse_history;

		 ptr<tex::document> doc_;
 };
 
};

#endif
