
#include <texdoc/eqtb.hh>
// FIXME: numbers.hh should not really be part of lib-layout.
#include <layout/numbers.hh>

#include <stdexcept>

using namespace tex;

template<class T>
tex_table<T>::tex_table(int num)
   {
   memory_=vector<pair<int,T> >(num);
   stack_ =vector<saver>(num);
   }

template<class T>
void tex_table<T>::set_user(int index,T value)
   {
   if(index >= (int)memory_.size())
		throw range_error("index outside of table range in set_user");
   pair<int,T> tmp(0,value);
   memory_[index]=tmp;
   }

template<class T>
T tex_table<T>::get_user(int index) const
   {
   if(index >= (int)memory_.size())
	 throw range_error("index outside of table range in get_user");
   return memory_[index].second;
   }

tex_eqtb::tex_eqtb(void)
   {
   for(unsigned int i=0; i<256; ++i)
		ccode_.set_user(i,cat::other_char);
	
   ccode_.set_user(15  ,cat::car_ret);
   ccode_.set_user(' ' ,cat::spacer);
   ccode_.set_user('\\',cat::escape);
   ccode_.set_user('%' ,cat::comment);
	
   for(unsigned int i='A'; i<='Z'; ++i) { 
		ccode_.set_user(i,cat::letter);
	   ccode_.set_user(i+'a'-'A',cat::letter);
		}
   }

