
#include <string>
#include <url/url_string.hh>
#include <vector.h>

#define DEBUG_CLASS "TESTURL"
#include <mnemonic/debug.hh>

void displayUrl(url_string *url)
	{
	
	cout << "original:    " << url->get_original() << endl;
	if(url->get_referrer()) {
		cout << "referrer:    " << url->get_referrer()->get_url() << endl;
		}
	cout << "relative:    " << url->get_relative_path() << endl
		  << "url:         " << url->get_url() << endl
		  << "object:      " << url->get_object() << endl
		  << "["<<url->get_scheme()<<"]"
		  << "//["<<url->get_username()<<"]"
		  << ":["<<url->get_passwd()<<"]"
		  << "@["<<url->get_net_path()<<"]"
		  << ":["<<url->get_port()<<"]"
		  << "["<<url->get_absolute_path()<<"]"
		  << ";["<<url->get_parameters()<<"]"
		  << "?["<<url->get_query()<<"]"
		  << "#["<<url->get_fragment()<<"]" << endl
		  << "-----" << endl << endl;
	}

int main(int argc, char *argv[]) 
	{
	int ac=1;
	while (ac < argc && argv[ac][0] == '-') {
		switch (argv[ac][1]) {
#ifdef DEBUG
			case 'd':
			case 'D':
				debugger::instance().turn_on(argv[ac]+2);
				break;
#endif
			default:
				cerr << "[test_url]: unknown option '" << argv[ac] << "'" << endl;
			}
		ac++;
		}

	cout<<"test url_string for correct working"<<endl;
	cout<<"add any usefull test to the file so it will be used when a new modification is tested"<<endl<<endl;
	string urlstr,refstr;

	refstr=urlstr="scheme://user:pass@host:999/path/file;param?query#fragment";
	url_string *url1=new url_string(urlstr.c_str());
	cout << urlstr << endl;
	displayUrl(url1);

	urlstr="/path2/file2";
	url_string *url2=new url_string(urlstr.c_str(),*url1);
	cout<<urlstr<<" "<<refstr<<endl;
	displayUrl(url2);

	urlstr="path3/file3";
	url2=new url_string(urlstr.c_str(),*url1);
	cout<<urlstr<<" "<<refstr<<endl;
	displayUrl(url2);

	urlstr="file4";
	url2=new url_string(urlstr.c_str(),*url1);
	cout<<urlstr<<" "<<refstr<<endl;
	displayUrl(url2);

	urlstr="//host2";
	url2=new url_string(urlstr.c_str(),*url1);
	cout<<urlstr<<" "<<refstr<<endl;
	displayUrl(url2);

	urlstr="#fragment2";
	url2=new url_string(urlstr.c_str(),*url1);
	cout<<urlstr<<" "<<refstr<<endl;
	displayUrl(url2);

	urlstr="?query2";
	url2=new url_string(urlstr.c_str(),*url1);
	cout<<urlstr<<" "<<refstr<<endl;
	displayUrl(url2);

	urlstr=";param2";
	url2=new url_string(urlstr.c_str(),*url1);
	cout<<urlstr<<" "<<refstr<<endl;
	displayUrl(url2);

	urlstr="http://scheme://host/path/file #chap1";
	url1=new url_string(urlstr.c_str());
	cout<<urlstr << endl;
	displayUrl(url1);
	
	urlstr="http://host.at.net/./path";
	url1=new url_string(urlstr.c_str());
	cout<<urlstr << endl;
	displayUrl(url1);
	}
