
#include <mnemonic/debug.hh>
#include <w3render/w3render.hh>
#include <iostream.h>

void fill_dom(ptr<DOM::Document> doc);
void fill_css(ptr<CSS::stylesheet> sheet);

int main(int argc, char **argv)
	{
	int ac=1;

	while (ac < argc && argv[ac][0] == '-') {
			switch (argv[ac][1]) {
				case 'h':
					cerr << "Usage: test_w3render [-dDEBUGCLASS]" << endl;
					exit(1);
#ifdef DEBUG
				case 'd':
					debugger::instance().turn_on(argv[ac]+2);
					break;
#endif
				}
			++ac;
		}

	ptr<DOM::Document>   doc  =new DOM::Document;
	ptr<CSS::stylesheet> sheet=new CSS::stylesheet(doc,0);
	
	w3renderer      rend(sheet);
	cbox_base *cb=1;
	rend.set_toplevel(cb);
	
	fill_dom(doc);
	fill_css(sheet);

	vector<DOM::Node *> mods;
	mods.push_back(doc->firstChild());
	try {
		if(rend.dom_to_layout(mods))
			cout << "tree modified" << endl;
		else
			cout << "tree not modified" << endl;
		}
	catch(exception& ex) {
		cerr << "exception: " << ex.what() << endl;
		}
	return 0;
	}


void fill_dom(ptr<DOM::Document> doc)
	{
	DOM::Node *t=0;

	t=&(*doc);
	t=t->appendChild(doc->createElement("HTML"));
	t=t->appendChild(doc->createElement("BODY"));
	t=t->appendChild(doc->createElement("H1"));
	t=t->appendChild(doc->createTextNode("title text"));
	}


// this is copied from csshandler.cc
void fill_css(ptr<CSS::stylesheet> cssptr)
	{
	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("H1"));
	decl1->set_display(CSS::declaration::block);
	decl1->set_font_size(new CSS::declaration::numberproperty(24,CSS::declaration::numberproperty::PX));
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("H2"));
	decl1->set_display(CSS::declaration::block);
	decl1->set_font_size(new CSS::declaration::numberproperty(18,CSS::declaration::numberproperty::PX));
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("H3"));
	decl1->set_display(CSS::declaration::block);
	decl1->set_font_size(new CSS::declaration::numberproperty(14,CSS::declaration::numberproperty::PX));
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("TT"));
	decl1->set_display(CSS::declaration::display_inline);
	decl1->set_font_family(new CSS::declaration::stringproperty("lucidatypewriter"));
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("PRE"));
	decl1->set_display(CSS::declaration::block);
	decl1->set_font_family(new CSS::declaration::stringproperty("lucidatypewriter"));
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("UL"));
	decl1->set_display(CSS::declaration::block);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("OL"));
	decl1->set_display(CSS::declaration::block);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("ADDRESS"));
	decl1->set_display(CSS::declaration::block);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("LI"));
	decl1->set_display(CSS::declaration::block);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("BLOCKQUOTE"));
	decl1->set_display(CSS::declaration::block);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("CODE"));
	decl1->set_display(CSS::declaration::display_inline);
	decl1->set_font_family(new CSS::declaration::stringproperty("lucidatypewriter"));
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("SCRIPT"));
	decl1->set_display(CSS::declaration::display_none);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("SMALL"));
	decl1->set_display(CSS::declaration::display_inline);
	decl1->set_font_size(new CSS::declaration::numberproperty(8,CSS::declaration::numberproperty::PX));
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("BIG"));
	decl1->set_display(CSS::declaration::display_inline);
	decl1->set_font_size(new CSS::declaration::numberproperty(12,CSS::declaration::numberproperty::PX));
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("FONT"));
	decl1->set_display(CSS::declaration::display_inline);
	decl1->set_font_size(new CSS::declaration::numberproperty(10,CSS::declaration::numberproperty::PX));
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("A"));
	decl1->set_display(CSS::declaration::display_inline);
	decl1->set_color(new CSS::declaration::colorproperty("blue"));
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("EM"));
	decl1->set_display(CSS::declaration::display_inline);
//	decl1->set_font_family(new CSS::declaration::stringproperty("helvetica"));
	decl1->set_font_style(CSS::declaration::font_oblique);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("SPAN"));
	decl1->set_display(CSS::declaration::display_inline);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("BR"));
	decl1->set_display(CSS::declaration::block); //FIXME: this one is to trigger a bug.
	// Apparently, inline boxes following block boxes following inline boxes are not stored
	// at the right place.
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("ACRONYM"));
	decl1->set_display(CSS::declaration::display_inline);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("CITE"));
	decl1->set_display(CSS::declaration::display_inline);
	decl1->set_font_style(CSS::declaration::font_oblique);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("DFN"));
	decl1->set_display(CSS::declaration::display_inline);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("DIV"));
	decl1->set_display(CSS::declaration::block);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("CENTER"));
	decl1->set_display(CSS::declaration::block);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("P"));
	decl1->set_display(CSS::declaration::block);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}


	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("TABLE"));
	decl1->set_display(CSS::declaration::table);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}
		
	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("TR"));
	decl1->set_display(CSS::declaration::table_row);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}
	  
	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("TD"));
	decl1->set_display(CSS::declaration::table_cell);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		} 

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("B"));
	decl1->set_display(CSS::declaration::display_inline);
	decl1->set_font_family(new CSS::declaration::stringproperty("helvetica"));
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("IMG"));
	decl1->set_display(CSS::declaration::display_inline);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("STRONG"));
	decl1->set_display(CSS::declaration::display_inline);
//	decl1->set_font_family(new CSS::declaration::stringproperty("helvetica"));
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("I"));
	decl1->set_display(CSS::declaration::display_inline);
//	decl1->set_font_family(new CSS::declaration::stringproperty("helvetica"));
	decl1->set_font_style(CSS::declaration::font_italic);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl1=new CSS::declaration;
	CSS::selector       *sele1=new CSS::selector;
	sele1->elements_.push_back(CSS::selector::selector_element("#document"));
	decl1->set_display(CSS::declaration::display_empty);
	CSS::rule *rule1=new CSS::rule(sele1,decl1);
	cssptr->add_rule(rule1);
		}

	{
	CSS::declaration    *decl2=new CSS::declaration;
	CSS::selector       *sele2=new CSS::selector;
	sele2->elements_.push_back(CSS::selector::selector_element("#text"));
	decl2->set_display(CSS::declaration::display_inline);
	CSS::rule *rule2=new CSS::rule(sele2,decl2);
	cssptr->add_rule(rule2);
		}
	}
