m4_include(common.h)

theHEADER(mkeyDisplayStatus (in msg_display))


SECTION([Syntax], [
<code>#include &lt;<a href="../include/msg/display/mkeyDisplayStatus.h">msg/display/mkeyDisplayStatus.h</a>&gt;<br>
mkeyDisplayStatus (int id, status s, const string &msg);</code>
])
SECTION([mkeyDisplayStatus], [
This message is send by the display when it's changed status. It is keyed with the display id and contains a <code>const string &msg</code> member with a message that can be displayed to the user. It also contains a <code>status stat</code> member indication the status. <code>status</code> is a enum typedef that can have the following values:
<dl>
<dt>OVERLINK</dt><dd>The mouse is currently on top of a link. <code>msg</code> contains the url.</dd>
<dt>LEFTLINK</dt><dd>The mouse is no longer on top of the link.  <code>msg</code> contains one single space to clear the status line.</dd>
</dl>
])
SECTION([Example], [
<pre>

InterestByKey<Browser,mkeyDisplayStatus, int> *interestDispStatus;
interestDispStatus = new InterestByKey<Browser,mkeyDisplayStatus, int>(
  this,&Browser::GotoURLMess);
interestDispStatus->AddKey(connNewId);

int Browser::DispStatusMess(mkeyDisplayStatus &m) {
	if (m.stat != mkeyDisplayStatus::LEFTLINK)
		cout &lt;&lt;"Display: "&lt;&lt;m.msg&lt;&lt;endl;
	return 0;
}

</pre>
])
theFOOTER
