// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  CSS events (creation, modification etc).

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef css_event_hh__
#define css_event_hh__

#include <mnemonic/messagebase.hh>
#include <mnemonic/ptr.hh>
#include <dom/css.hh>

class msg_css_event : public message<msg_css_event> {
	public:
};

class msg_css_create_event : public msg_css_event, public message<msg_css_create_event> {
	public:
		ptr<CSS::stylesheet>              new_css_sheet;
		DOM::Node                        *start_here;
		virtual untyped_message::send_result send(void);
};
	
#endif
