// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Messages used by the parser to report parsing errors.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef dom_event_hh__
#define dom_event_hh__

#include <string>
#include <mnemonic/messagebase.hh>
#include <mnemonic/ptr.hh>
#include <dom/dom.hh>

#include <url/url_string.hh>

class msg_parse_error : public message<msg_parse_error> {
	public:
		msg_parse_error(const url_string&, long, const string&);

		url_string url;
		long       line_number;
		string     error_text;
};

#endif
