// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  W3C DOM events implemented using mnemonic messages.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <msg/dom/dom_event.hh>

untyped_message::send_result msg_dom_ui_event::send(void) 
	{
	untyped_message::send_result s1,s2;
	
	try {
		s1=message<msg_dom_ui_event>::send();
		s2=message<msg_dom_event>::send();
		}
	catch(messagebase_error &ex) {
		if(s1.is_unset())
			s2=message<msg_dom_event>::send();
		}
	return untyped_message::send_result(s1.number_of_receivers()+s2.number_of_receivers());
	}

untyped_message::send_result msg_dom_create_event::send(void) 
	{
	untyped_message::send_result s1,s2;
	
	try {
		s1=message<msg_dom_create_event>::send();
		s2=message<msg_dom_event>::send();
		}
	catch(messagebase_error &ex) {
		if(s1.is_unset())
			s2=message<msg_dom_event>::send();
		}
	return untyped_message::send_result(s1.number_of_receivers()+s2.number_of_receivers());
	}

untyped_message::send_result msg_dom_parser_detached_event::send(void) 
	{
	untyped_message::send_result s1,s2;
	
	try {
		s1=message<msg_dom_parser_detached_event>::send();
		s2=message<msg_dom_event>::send();
		}
	catch(messagebase_error &ex) {
		if(s1.is_unset())
			s2=message<msg_dom_event>::send();
		}
	return untyped_message::send_result(s1.number_of_receivers()+s2.number_of_receivers());
	}

untyped_message::send_result msg_dom_mutation_event::send(void) 
	{
	untyped_message::send_result s1,s2;
	
	try {
		s1=message<msg_dom_mutation_event>::send();
		s2=message<msg_dom_event>::send();
		}
	catch(messagebase_error &ex) {
		if(s1.is_unset())
			s2=message<msg_dom_event>::send();
		}
	return untyped_message::send_result(s1.number_of_receivers()+s2.number_of_receivers());
	}

untyped_message::send_result msg_dom_html_event::send(void) 
	{
	untyped_message::send_result s1,s2;
	
	try {
		s1=message<msg_dom_html_event>::send();
		s2=message<msg_dom_event>::send();
		}
	catch(messagebase_error &ex) {
		if(s1.is_unset())
			s2=message<msg_dom_event>::send();
		}
	return untyped_message::send_result(s1.number_of_receivers()+s2.number_of_receivers());
	}

untyped_message message<msg_dom_event>::static_part;
untyped_message message<msg_dom_ui_event>::static_part;
untyped_message message<msg_dom_create_event>::static_part;
untyped_message message<msg_dom_parser_detached_event>::static_part;
untyped_message message<msg_dom_mutation_event>::static_part;
untyped_message message<msg_dom_html_event>::static_part;

template message<msg_dom_event>;
template message<msg_dom_ui_event>;
template message<msg_dom_create_event>;
template message<msg_dom_parser_detached_event>;
template message<msg_dom_mutation_event>;
template message<msg_dom_html_event>;

template interest_base<msg_dom_event>;
template interest_base<msg_dom_ui_event>;
template interest_base<msg_dom_create_event>;
template interest_base<msg_dom_parser_detached_event>;
template interest_base<msg_dom_mutation_event>;
template interest_base<msg_dom_html_event>;

