// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Messages used by the parser to report parsing errors.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <msg/dom/parse_error.hh>

msg_parse_error::msg_parse_error(const url_string& u, long l, const string& e)
	: url(u), line_number(l), error_text(e)
	{
	}

untyped_message message<msg_parse_error>::static_part;
template message<msg_parse_error>;
template interest_base<msg_parse_error>;

