m4_include(common.h)

theHEADER(mkeyGTKObjectReady (in msg_display))


SECTION([Syntax], [
<code>#include &lt;<a href="../include/msg/gtkdisplay/mkeyGTKObjectReady.h">msg/gtkdisplay/mkeyGTKObjectReady.h</a>&gt;<br>
mkeyGTKObjectReady (int id, GtkWidget *obj);</code>
])
SECTION([mkeyGTKObjectReady], [
This message is sent by the last filter to announce the object created
as a response to a 
<a href="../../mnemonic-msg-filter/doc/mBuildFilterStack.html">mBuildFilterStack</a>
(id, "Display/GTK"); call. The <code>GtkWidget *object</code> member points
to the newly created object.
])
SECTION([mkeyGTKObjectReady], [
To get hold of the "Display/GTK" object created in the 
<a href="../../mnemonic-msg-filter/doc/mBuildFilterStack.html">mBuildFilterStack</a>
example you could:
<pre>
InterestByKey<gtkPreImage,mkeyGTKObjectReady,int> *objinterest;
objinterest=new InterestByKey<gtkPreImage, mkeyGTKObjectReady,int>(this,&ObjRdyMess);
objinterest->AddKey(id);

/* Make the mBuildFilterStack stuff */

int ObjRdyMess(mkeyGTKObjectReady &m) {
  /* Displaying the new object... */
  gtk_box_pack_end(GTK_BOX(dispcontainer), dispObj, TRUE, TRUE, 0);
  return 0;
}
</pre>
])

