m4_include(common.h)

theHEADER(mkeyGTKTagReady (in msg_display))


SECTION([Syntax], [
<code>#include &lt;<a href="../include/msg/gtkdisplay/mkeyGTKTagReady.h">msg/gtkdisplay/mkeyGTKTagReady.h</a>&gt;<br>
mkeyGTKTagReady (int id, gtkTag *obj);</code>
])
SECTION([mkeyGTKTagReady], [
This message is sent by the last filter to announce the object created
as a response to a 
<a href="../../mnemonic-msg-filter/doc/mBuildFilterStack.html">mBuildFilterStack</a>
(id, "Tag/GTK"); call. The <code>gtkTag *object</code> member points
to the newly created object.
])
SECTION([mkeyGTKTagReady], [
To get hold of a "Tag/GTK" object created like the object in the 
<a href="../../mnemonic-msg-filter/doc/mBuildFilterStack.html">mBuildFilterStack</a>
example you could:
<pre>
InterestByKey<gtkPreImage,mkeyGTKTagReady,int> *objinterest;
objinterest=new InterestByKey<gtkPreImage, mkeyGTKTagReady,int>(this,&ObjRdyMess);
objinterest->AddKey(id);

/* Make the mBuildFilterStack stuff */

int ObjRdyMess(mkeyGTKTagReady &m) {
  TagNode root;
  root.AddChild(m.object);
  return 0;
}
</pre>
])

