// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Network layer status messages, interface.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.

  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef network_status_hh__
#define network_status_hh__

#include <mnemonic/messagebase.hh>
#include <url/url_string.hh>

class msg_network_status : public message<msg_network_status> {
	public:
		enum status { looking_up, bad_host, timed_out, network_unreachable, connection_refused,
		              connecting, bad_connection, closed, stalled, alive, sending_request, request_sent, 
		              unexpected_eof, finished, redirected, content, 
		              authentication, bad_id, generic_error, read_error,
		              object_truncated, open_error, connection_failed,
		              wrong_authentication, no_route };

		msg_network_status(status ident, const char *txt, const url_string& ur);

		status      identifier; 
		string      text;
		url_string  url; // FIXME: should that sit here? No, not really, since you can keep track
		// of urls somewhere else (as we do in client right now. But for status messages it is useful.
		string      status_as_text(void) const;
};

#endif
