// -*- mode: C++; c-file-style: "mnemonic"; -*-

#include <string>
#include <msg/demo/mTest.h>
#include <mnemonic/objectmanager.hh>
#include <stdio.h>
#include <unistd.h>
#include <mnemonic/memdebug.hh>
#include <mnemonic/debugger.hh>
#include "malloc.h"
#include <stdlib.h>
#include <stdexcept>

int main(int argc, char *argv[]) 
	{
	int ac=1;
	
	while (ac < argc && argv[ac][0] == '-') {
		switch (argv[ac][1]) {
#ifdef DEBUG
			case 'd':
			case 'D':
				debugger::instance().turn_on(argv[ac]+2);
				break;
#endif      
			default:
				printf ("Unknown option: %s\n", argv[ac]);
			}
		ac++;
		}
	
	cerr << "loading interests..." << endl << endl;
	object_manager::instance().load_interests();
	
	cerr << "We are going to send three messages. The first one will be" << endl
		  << "a normal `mTest'. It will be received by the interests in" << endl
		  << "the order in which the interests were declared. The testoil," << endl
		  << "upon receiving this message, registers the group_id of the" << endl
		  << "message on the interest_mTest_priority_ interest." << endl << endl
		  << "We then send the message again. The order in which the" << endl
		  << "interests receive it is now reversed, because of the above." << endl << endl
		  << "The third message is a `mTest_derived'. This is received by" << endl
		  << "two interests; the priority one only listens to the given" << endl 
		  << "midentifier group." << endl << endl;
	try { 
		mTest m;
		m.number=1;
		cerr << "sending normal message" << endl;
		cerr << "number of receivers was " << m.send().number_of_receivers() << endl << endl;
		cerr << "sending message again" << endl;
		midentifier tmpid;
		m.add_group_id(tmpid);
		cerr << "number of receivers was " << m.send().number_of_receivers() << endl << endl;
		mTest_derived dm;
		dm.number=2;
		dm.extra=10;
		cerr << "sending derived message" << endl;
		cerr << "number of receivers was " << dm.send().number_of_receivers() << endl << endl;
		}
	catch (messagebase_error& ex) {
		cerr << ex << endl;
		exit(1);
		}
	catch (exception& ex) {
		cerr << "[exception]: " << ex.what() << endl;
		exit(1);
		}
	cerr << "cleaning up\n";cerr.flush();
	cerr << "messages deleted\n";cerr.flush();
	object_manager::free_instance();
	cerr << "object_manager freeed\n";cerr.flush();
	}

