// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Demo OIL message handling.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "testoil.h"

testoil::testoil(void)
	{
	interest_mTest_priority_=
		interest<testoil, mTest>::create(this, &(testoil::accept_mTest_priority),untyped_interest::lowest);
	interest_mTest_priority_->acceptance=untyped_interest::ignore_ids;
   interest_mTest_=
		interest<testoil, mTest>::create(this, &(testoil::accept_mTest),untyped_interest::lowest);
	interest_mTest_->acceptance=untyped_interest::ignore_ids;
   interest_mTest_derived_=
		interest<testoil, mTest_derived>::create(this, &(testoil::accept_mTest_derived), 
															  untyped_interest::lowest);
	interest_mTest_derived_->acceptance=untyped_interest::ignore_ids;
	}

untyped_interest::callresult testoil::accept_mTest(mTest& m)
   {
   cout << "[testoil]: received test message; number=" << m.number << " " 
		  << *(m.ids.begin()) << endl;
   return untyped_interest::call_next;
   }

untyped_interest::callresult testoil::accept_mTest_priority(mTest& msg)
   {
   cout << "[testoil]: received test message with priority; number=" << msg.number << " " 
		  << *static_cast<group_identifiers *>(&msg) << endl;
	if(interest_mTest_priority_->ids.size()==0) {
		cout << "registering special priority interest for this midentifier." << endl;
		interest_mTest_priority_->set_group_ids(msg);
		interest_mTest_priority_->acceptance=untyped_interest::iid_contains_mid;
		}
   return untyped_interest::call_next;
   }

untyped_interest::callresult testoil::accept_mTest_derived(mTest_derived& msg)
   {
   cout << "[testoil]: received derived test message; number=" 
		  << msg.number << ", extra=" << msg.extra << " " 
		  << *static_cast<group_identifiers *>(&msg) << endl;
   return untyped_interest::call_next;
   }

template interest<testoil,mTest>;
template interest<testoil,mTest_derived>;


