// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Mnemonic http thread (does all the work)

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef file_thread_hh_
#define file_thread_hh_

#include "file_handler.hh"
#include <tcpcon/tcp_connection.hh>
#include <mnemonic/thread.hh>
#include <mnemonic/midentifier.hh>
#include <msg/network/network_status.hh>
#include <msg/network/stop.hh>
#include <url/url_string.hh>

class file_thread : public thread {
	public:
		file_thread(const url_string &,file_handler *, const group_identifiers &);
		~file_thread();
		void begin();
		void cancel(void);
		untyped_interest::callresult    accept_stop(msg_stop &);
	private:
		group_identifiers ids_;
		url_string url_;
		file_handler *hh_;
		int response_code_;

		void send_status_(msg_network_status::status, const string&);
		void send_status_(msg_network_status::status);


		void readdir();
		void readfile();
		
		int should_exit_;
		int read_(int,char *,int);


		ptr<interest<file_thread,msg_stop> >  interest_stop_;
		void setup_interests_();
		void remove_interests_();
};
#endif
