// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Mnemonic http thread (does all the work)

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define DEBUG_CLASS "file_thread"
#include <mnemonic/debug.hh>
#include "file_thread.hh"

void file_thread::setup_interests_() 
	{
	interest_stop_ = interest<file_thread, msg_stop>::create(this,&file_thread::accept_stop,untyped_interest::lowest);
	interest_stop_->acceptance=untyped_interest::iid_contains_mid;
	interest_stop_->add_group_ids(ids_);
	}

void file_thread::remove_interests_() 
	{
	interest_stop_->unregister();
	interest_stop_.wait();
	}

untyped_interest::callresult file_thread::accept_stop(msg_stop &m) 
	{
	debug("file_thread stopped");
	interest_stop_->remove_group_ids(ids_);
	send_status_(msg_network_status::object_truncated);
	should_exit_ = 1;
	return untyped_interest::call_next;
	}

template interest<file_thread, msg_stop>;
