// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Mnemonic http thread (does all the work)

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef ftp_ctrl_thread_hh_
#define ftp_ctrl_thread_hh_

#include "ftp_handler.hh"
#include <mnemonic/thread.hh>
#include <mnemonic/midentifier.hh>
#include <msg/network/network_status.hh>
#include <msg/network/stop.hh>
#include "ftp_url.hh"

class ftp_data_thread;
class tcp_connection;

class ftp_ctrl_thread : public thread {
	public:
		ftp_ctrl_thread(const ftp_url &,ftp_handler *, const midentifier &);
		~ftp_ctrl_thread();
		void begin();
		void cancel(void);
		untyped_interest::callresult    accept_stop(msg_stop &);
	private:
		ftp_data_thread *fdt_;
		tcp_connection *ftp_ctrl_;
		int fd_;
		midentifier id_;
		ftp_url url_;
		ftp_handler *hh_;
		int response_code_;

		void send_status_(msg_network_status::status, const char *);
		void send_status_(msg_network_status::status);

		int connect_();
		int send_request_();

		int should_exit_;
		int read_(char *,int);
		int write_(string);
		int to_code_(char *);
		int read_num_();
		ptr<interest<ftp_ctrl_thread,msg_stop> >  interest_stop_;
		void setup_interests_();
		void remove_interests_();
};
#endif
