// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Mnemonic http thread (does all the work)

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef ftp_data_thread_hh_
#define ftp_data_thread_hh_
#include "ftp_url.hh"
#include <mnemonic/thread.hh>
#include <mnemonic/midentifier.hh>

class ftp_data_thread:public thread {
public:
  ftp_data_thread();
  ftp_data_thread(const ftp_url &, const midentifier &);
  virtual ~ftp_data_thread();
  void begin();
  void cancel();
  int setup_receive_port();
  string addr; //address in xxx.xxx.xxx.xxx format
  int port;    //port available for connection
  virtual int send_content();
  int setup_connect_port(char *);
  int should_exit_;
  int pfd_[2];
  ftp_url url_;
  int fd_;	//socket
  int send_finished();
  int send_closed();
  midentifier id_;
  enum FTPMODE {
    PORT,PASV
  };
  FTPMODE mode;
};


#endif