#include "ftp_list_thread.hh"
#include <unistd.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/select.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <msg/network/network_status.hh>
#include <msg/network/network_data.hh>
#define DEBUG_CLASS "ftp_list_thread"
#include <mnemonic/debug.hh>


ftp_list_thread::ftp_list_thread()
	{
	debug("construct()");
	nod();
	}

ftp_list_thread::ftp_list_thread(const ftp_url &url, const midentifier &id)
	{
	url_=url;
	id_=id;
	pipe(pfd_);
	debug("construct(url,id)");
	}

int ftp_list_thread::send_content()
	{
	debug("Sending content message   to " << id_);	
	msg_network_status ms(msg_network_status::content, "text/html", url_);
	ms.add_group_id(id_);
	try { ms.send(); }                                 
	catch(messagebase_error& ex) {                               
		debug(ex);
		//throw;  we don't care whether someone receives this
		}
	debug("Done sending content message");
	return 0; //later maybe a more advanced feadback?
	}

void ftp_list_thread::begin()
	{
	debug("thread started for watching data");
	fd_set mask;
	FD_ZERO(&mask);
	FD_SET(fd_,&mask);
	nod();
	FD_SET(pfd_[0],&mask);
	nod();
	select(getdtablesize(),&mask,0,0,0);
	nod();
	if (FD_ISSET(pfd_[0],&mask)) {
		//we're told to stop
		return;
  }
	//if (!FD_ISSET(fd_,&mask)) {
	//hmm this is not supposed to be!!
	//}
	debug("accepting data");
	int fd2;
	if (mode==PORT) {
	  struct sockaddr_in sin;
	  unsigned int si=sizeof(sin);
	  fd2=accept(fd_,(sockaddr *)&sin,&si);
	} else {
	  fd2=fd_;
	}
	{
		//sent pre block
		string prefab;
		prefab="<HTML>\n<HEAD>\n<TITLE>"+url_.get_url()+"</TITLE>\n</HEAD>\n<BODY>\n";
		msg_network_data mnd(prefab.c_str(),prefab.size());
		mnd.add_group_id(id_);
		debug("msg constructed");
		try { mnd.send(); } 
		catch(messagebase_error&ex) {
			debug("for id " << id_ << ":" << endl << ex); 
			}
		}
	string restline="";
        bool done=false;
	while(!done) {
		FD_ZERO(&mask);
		FD_SET(fd2,&mask);
		FD_SET(pfd_[0],&mask);
		select(getdtablesize(),&mask,0,0,0);
		if (FD_ISSET(pfd_[0],&mask)) {
			//we're told to stop
			send_closed();
			done=true;
			}
		if (FD_ISSET(fd2,&mask)) {
			char buf[1025];
			int i=read(fd2,buf,1024);
			switch(i) {
				case 0:
					//send finished message! 
					debug("transfer finished?");
					{
						//sent pre block
						string prefab;
						prefab="</BODY>\n";
						msg_network_data mnd(prefab.c_str(),prefab.size());
						mnd.add_group_id(id_);
						debug("msg constructed");
						try { mnd.send(); } 
						catch(messagebase_error&ex) {
							debug("for id " << id_ << ":" << endl << ex); 
							}
						}
					send_finished();
					done=true;
					break;
				case -1:
					debug("error");
					send_closed();
					//error
					done=true;
					break;
				default:
					debug("Got a chunk of data to send as a data message");
					buf[i]=0;
					string prefab="";
					int j=0;
					nod();
					while (buf[j]!=0) {
						nod();
						while (buf[j]!=0 && buf[j]!='\n') {
							nod();
							if (buf[j]!='\r') restline+=buf[j];
							j++;
							}
						
						if (buf[j]=='\n') {
							prefab+="<A HREF=\""+restline+"\">"+restline+"</A><BR>\n";
							restline="";
							j++;
							}
						}
					nod();
					debug(prefab);
					msg_network_data mnd(prefab.c_str(),prefab.size());
					mnd.add_group_id(id_);
					debug("msg constructed");
					try { mnd.send(); } 
					catch(messagebase_error&ex) {
						debug("for id " << id_ << ":" << endl << ex); 
						}
				}
			}
		}
	if (mode==PORT)
		close(fd2);
	}



