// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  GTK based display.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "gtkdisplay.hh"

#include <gtk--/widget.h>
#include <gdk--.h>

void gtkdisplayhandler::add_w3renderer_(const group_identifiers& gid, ptr<CSS::stylesheet> cssptr,
													 DOM::Node *startnode)
	{
	mutex_.lock();
	map<group_identifiers, gtkw3renderer *>::iterator it=active_renderers_.begin();
	while(it!=active_renderers_.end()) {
		// the renderer will take care of shutting down message handling.
		delete (*it).second;
		active_renderers_.erase(it);
		++it;
		}
	gtkw3renderer *rend=new gtkw3renderer(gid,cssptr,startnode);
	active_renderers_[gid]=rend;
	mutex_.unlock();

	msg_dom_mutation_event dm;
	dm.document=cssptr->document();
	// we do this only once, just to make sure no events get lost. 
	// FIXME: we should probably put this sort of logic in the messagebase.
	rend->accept_dom_mutation_event(dm);
	}

extern "C" 
	{
	dlobject *create_gtkdisplay(void**);
	}

dlobject *create_gtkdisplay(void** /* Args */) 
	{
	return new gtkdisplayhandler();
	}

template map<group_identifiers, gtkw3renderer *>;
