// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  GTK based display.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#define DEBUG_CLASS "GTKDISPLAY"
#include <mnemonic/debug.hh>
#include <unistd.h>

#include <msg/dom/dom_event.hh>
#include <msg/dom/css_event.hh>
#include <msg/gtkdisplay/object_ready.hh>
#include <gtklayout/gtkboxes.hh>
#include <gtk--/button.h>
#include <gtk--.h>

#include "gtkdisplay.hh"

gtkdisplayhandler::gtkdisplayhandler(void)
	{
	interest_css_create_event_=interest<gtkdisplayhandler, msg_css_create_event>::create(
		this, &gtkdisplayhandler::accept_css_create_event,untyped_interest::lowest);
	}

gtkdisplayhandler::~gtkdisplayhandler()
	{
	interest_css_create_event_->unregister();
	interest_css_create_event_.wait();
	}

untyped_interest::callresult gtkdisplayhandler::accept_css_create_event(msg_css_create_event & msg)
	{
	debug("informed about new CSSStyled document");

	// All CSS'ed documents get announced this way.This module accepts
	// HTML as the root tag, and the image handler will accept the IMG
	// tag and so on.

	if(msg.start_here && msg.start_here->nodeName()=="HTML") {
		add_w3renderer_(msg, msg.new_css_sheet, msg.start_here);
		return untyped_interest::call_next;
		}
	else {
		debug("sorry, tree does not start with HTML");
		return untyped_interest::pass_on;
		}
	}

template interest<gtkdisplayhandler, msg_css_create_event>;

