// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  GTK based image display.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "gtkimagedisplay.hh"

#define DEBUG_CLASS "GTKIMAGEDISPLAY"
#include <mnemonic/debug.hh>
#include <gtk--/widget.h>
#include <gdk--.h>

gtkimagerenderer *gtkimagedisplayhandler::add_imagerenderer_(const group_identifiers& gid, 
																ptr<CSS::stylesheet> cssptr, DOM::Node *starthere)
	{
	mutex_.lock();
/*	map<group_identifiers, gtkimagerenderer *>::iterator it=active_renderers_.begin();
	while(it!=active_renderers_.end()) {
		delete (*it).second;
		interest_dom_mutation_event_->remove_group_ids((*it).first);
		active_renderers_.erase(it);
		++it;
		} */
	debug(gid);
	gtkimagerenderer *rend=new gtkimagerenderer(gid,cssptr,starthere);
	active_renderers_[gid]=rend;
	mutex_.unlock();

	// FIXME: it is not very smart to start up a new renderer this way
	// for every image, since pages may one image multiple times and we would
	// like to re-use the image data of another renderer. So maybe we should split 
	// off the DOM `parsing' code from the renderer and do that here, so that we
	// can check whether there is already a renderer for a given image. Or something
	// like that.

	rend->announce(gid);
	return rend;
	}

extern "C" 
	{
	dlobject *create_gtkimagedisplay(void**);
	}

dlobject *create_gtkimagedisplay(void** /* Args */) 
	{
	return new gtkimagedisplayhandler();
	}

template map<group_identifiers, gtkimagerenderer *>;
