
// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  GTK based image display.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef gtkimagedisplay_hh__
#define gtkimagedisplay_hh__

#include <string>
#include <map.h>

#include <mnemonic/dlobject.hh>
#include <msg/dom/dom_event.hh>
#include <msg/dom/css_event.hh>
#include <dom/dom.hh>

#include "gtkimagerenderer.hh"

class gtkimagedisplayhandler : public dlobject {
	public:
		gtkimagedisplayhandler(void);
		~gtkimagedisplayhandler();

		untyped_interest::callresult accept_css_create_event(msg_css_create_event &);
		untyped_interest::callresult accept_dom_mutation_event(msg_dom_mutation_event & msg);

	private:
		thread_mutex mutex_; 

		ptr<interest<gtkimagedisplayhandler, msg_css_create_event> >    interest_css_create_event_;
		ptr<interest<gtkimagedisplayhandler, msg_dom_mutation_event> >  interest_dom_mutation_event_;

		gtkimagerenderer *add_imagerenderer_(const group_identifiers&, ptr<CSS::stylesheet>, DOM::Node *);
		map<group_identifiers, gtkimagerenderer *> active_renderers_;
};


#endif
