// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Handler that spawns external helper programs for data streams
  of specific mime types.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef helperhandler_hh__
#define helperhandler_hh__

#include <mnemonic/dlobject.hh>
#include <msg/network/network_status.hh>
#include <msg/network/network_data.hh>

#include <map.h>

// Got renamed from helperhandler because the perl doc script got
// upset by the use of the m*me word. Sheesh.

class helperhandler : public dlobject {
   public:
		helperhandler(void);
		~helperhandler();

		untyped_interest::callresult accept_network_status(msg_network_status & msg);
		untyped_interest::callresult accept_network_data(msg_network_data & msg);
   private:
		thread_mutex mutex_; 

		ptr<interest<helperhandler,msg_network_status> > interest_network_status_;
		ptr<interest<helperhandler,msg_network_data> >   interest_network_data_;

//		map<group_identifiers, xmlparser *> active_parsers_;
};

#endif
