// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Mnemonic http url implementation.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "http_url.hh"
#define DEBUG_CLASS "http_url"
#include <mnemonic/debug.hh>

http_url::http_url() : url_string() 
	{
	    debug("http_url");
	}

http_url::http_url(const url_string &u) 
	: url_string(u) 
	{
	    debug("http_url");
	    if (port==0) port=default_port();
	}

http_url::http_url(const char *u, const url_string &u2) 
	: url_string(u,u2) 
	{
	    debug("http_url");
	    if (port==0) port=default_port();
	}

int http_url::default_port(void) const
	{
	debug("setting default port to 80");
	return 80;
	}
