// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  GTK based rendering unit (one for each document).

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "gtkrenderer.hh"

#define DEBUG_CLASS "GTKRENDERER"
#include <mnemonic/debug.hh>

gtkw3renderer::gtkw3renderer(const group_identifiers& ids, ptr<DOM::Document> doc)
	: w3renderer(doc), canvas_added_(false), my_ids_(ids)
	{
	}

gtkw3renderer::~gtkw3renderer()
	{
	}

gtkw3renderer::testwidget::~testwidget()
	{ 
	debug("~testwidget");
	// The gtkrenderer has to be notified of this, so that it no longer
	// updates this widget. Lower layers (parser, network) will pick up this
	// change by virtue of the fact that gtkdisplayhandler no longer listens
	// to msg_dom_mutation_event messages.
	}

void gtkw3renderer::connect_signals_(gtkw3renderer::testwidget *tmp)
	{
	// FIXME: yeah, I know this is ugly ;-) [kasper]
	connect_to_method(
		tmp->scanvas()->get_parent()->get_parent()->get_parent()->get_parent()->key_press_event, 
		tmp->scanvas()->canvas(), 
		&gtkcanvas::key_press_event_impl);
	}

int gtkw3renderer::widget_deleted(GdkEventAny *)
	{
	debug("WIDGET DELETED");
	return 0;
	}

cssbox *gtkw3renderer::create_cssbox(void)
	{
	return 0;
	}
