// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  GTK based rendering unit (one for each document).

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef gtkrenderer_hh__
#define gtkrenderer_hh__

#include <gdk--.h>
#include <gtk--/widget.h>

#include <msg/dom/dom_event.hh>

#include <mnemonic/ptr.hh>
#include <gtklayout/gtkboxes.hh>
#include <w3render/w3render.hh>
#include <msg/gtkdisplay/object_ready.hh>

class gtkw3renderer : public w3renderer {
	public:
		gtkw3renderer(const group_identifiers&, ptr<DOM::Document>);
		virtual ~gtkw3renderer();
		
		int widget_deleted(GdkEventAny *);

		class testwidget : public gtkviewer {
			public:
				testwidget(void) : gtkviewer() {};
				virtual ~testwidget();
		};

		// FIXME: gtkdisplay calls this directly, so we do not have an interest.
		// I agree, it's ugly.
		untyped_interest::callresult gtkw3renderer::accept_dom_mutation_event(msg_dom_mutation_event & msg);
		virtual cssbox *create_cssbox(void);
	private:		
		msg_gtk_object_ready msg2;           // FIXME: ugly too, but I just want to get it running now
		bool                 canvas_added_;
		group_identifiers    my_ids_;

		void connect_signals_(testwidget *);
};


#endif
