// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  GTK based rendering unit (one for each document).

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "gtkrenderer.hh"
#include <msg/gtkdisplay/object_ready.hh>

#define DEBUG_CLASS "GTKRENDERER"
#include <mnemonic/debug.hh>

untyped_interest::callresult gtkw3renderer::accept_dom_mutation_event(msg_dom_mutation_event & msg)
	{
	debug("Document was modified, updating display");

	if(!canvas_added_) {
		debug("Creating canvas widget");
		msg2.set_group_ids(msg);
		gtkw3renderer::testwidget *tmp=new gtkw3renderer::testwidget;
		msg2.widget=tmp->scanvas();
		debug("viewer widget created");
		
		debug("sending message");
		// this will give us a lock on gtk_in_use as well, plus an interrupted gtk event loop
		try {
			msg2.send();
			}
		catch(messagebase_error &ex) {
			debug(ex);
			delete msg2.widget;
			return untyped_interest::pass_on; 
			}
		
		tmp->freeze_width(super_number(tmp->scanvas()->get_parent()->width()));
		connect_signals_(tmp);
		tmp->outside_clip(false);
		tmp->scanvas()->get_parent()->show_all();
		
		canvas_added_=true;
		}
	else {
		debug("locking client");
		msg2.display_working->lock();
		write(msg2.fd,"a",1);
		msg2.gtk_in_use->lock();
		msg2.waiting->lock();
		}




	debug("releasing client");
	msg2.gtk_in_use->broadcast();
	msg2.gtk_in_use->unlock();
	msg2.waiting->wait();
	msg2.waiting->unlock();
	msg2.display_working->unlock();
		
	return untyped_interest::call_next;
	}


