// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  DTD class.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef fakedtd_hh_
#define fakedtd_hh_

#include <string>
#include <set.h>
#include <multimap.h>


class fakedtd {
	public:
		bool   valid_child(const string& parent, const string& child) const;
		bool   explicitly_disallowed(const string& parent, const string& child) const;
		bool   empty_element(const string& el) const;
	   string find_optional_enclosing_tag(const string& el) const;
		bool   optional_endtag(const string& el) const;
		bool   can_contain_brackets(const string& el) const;
		bool   keep_whitespace(const string& el) const;
	protected:
		void allowchild_(const string& parent, const string& child);
		void entity_(const string& parent, const string& child);
		void pos_(const string& parent, const string& child);
		void neg_(const string& parent, const string& child);

		typedef multimap<string, string, less<string> >::const_iterator const_iterator;
		typedef pair<const_iterator, const_iterator> range;

		multimap<string, string, less<string> >  entities;

		multimap<string, string, less<string> >  allow;
		multimap<string, string, less<string> >  pos;
		multimap<string, string, less<string> >  neg;
	   set<string, less<string> >               optstart;
	   set<string, less<string> >               optend;
		set<string, less<string> >               empty;
		set<string, less<string> >               rawtext;
		set<string, less<string> >               keepwhite;
};


#endif
