#include "dtd.hh"

#include <algo.h>

string fakedtd::find_optional_enclosing_tag(const string& el) const
	{
	set<string, less<string> >::const_iterator it=optstart.begin();
	while(it!=optstart.end()) {
		if(valid_child((*it),el)) {
			return (*it);
			}
		++it;
		}
	return "";
	}

bool fakedtd::explicitly_disallowed(const string& parent, const string& child) const
	{
	bool disallowed_=false;

	// This does not handle all cases, but I don't care at the moment.

	fakedtd::range ran=neg.equal_range(parent);
	while(ran.first!=ran.second) {
		if((*ran.first).second==child) {
			disallowed_=true;
			break;
			}
		++(ran.first);
		}
	
	return disallowed_;
	}

bool fakedtd::valid_child(const string& parent, const string& child) const
	{
	// For each entity (including itself) to which parent belongs, check whether child
	// is allowed as child. If parent allows an entity as a child, see if child belongs
   // to this entity.
	
	bool allowed_=false;

	fakedtd::range ran=allow.equal_range(parent);
	while(ran.first!=ran.second) {
		if(((*ran.first).second).substr(0,1)=="%") {
			range ran2=entities.equal_range(child);
			while(ran2.first!=ran2.second) {
				if((*ran2.first).second==(*ran.first).second) {
					allowed_=true;
					break;
					}
				++(ran2.first);
				}
			}
		else if((*ran.first).second==child) {
			allowed_=true;
			break;
			}
		++(ran.first);
		}

	if(!allowed_) {
		fakedtd::range ent=entities.equal_range(parent);
		while(ent.first!=ent.second) {
			fakedtd::range ran=allow.equal_range((*ent.first).second);
			while(ran.first!=ran.second) {
				if(((*ran.first).second).substr(0,1)=="%") {
					range ran2=entities.equal_range(child);
					while(ran2.first!=ran2.second) {
						if((*ran2.first).second==(*ran.first).second) {
							allowed_=true;
							break;
							}
						++(ran2.first);
						}
					}
				else if((*ran.first).second==child) {
					allowed_=true;
					break;
					}
				++(ran.first);
				}
			++(ent.first);
			}
		}

	if(allowed_)
		if(explicitly_disallowed(parent,child))
			return false;

	return allowed_;
	}


bool fakedtd::empty_element(const string& el) const
	{
	if(empty.find(el)==empty.end()) return false;
	else return true;
	}

bool fakedtd::optional_endtag(const string& el) const
	{
	if(optend.find(el)==optend.end()) return false;
	else return true;
	}

bool fakedtd::can_contain_brackets(const string& el) const
	{
	if(rawtext.find(el)==rawtext.end()) return false;
	else return true;
	}

bool fakedtd::keep_whitespace(const string& el) const
	{
	if(keepwhite.find(el)==keepwhite.end()) return false;
	else return true;
	}
