#include "xmlparser.hh"

#include <algo.h>

htmldtd::htmldtd(void)
	{
	// This is HTML 4.0 Transitional.
   // "-//W3C//DTD HTML 4.0 Transitional//EN"
 
	allowchild_("#document","HTML");

	entity_("%head.misc", "SCRIPT");
	entity_("%head.misc", "STYLE");
	entity_("%head.misc", "META");
	entity_("%head.misc", "LINK");
	entity_("%head.misc", "OBJECT");

	entity_("%heading","H1");
	entity_("%heading","H2");
	entity_("%heading","H3");
	entity_("%heading","H4");
	entity_("%heading","H5");
	entity_("%heading","H6");

	entity_("%list","UL");
	entity_("%list","OL");
	entity_("%list","DIR");
	entity_("%list","MENU");

	entity_("%preformatted","PRE");
	
	entity_("%fontstyle","TT");
	entity_("%fontstyle","I");
	entity_("%fontstyle","B");
	entity_("%fontstyle","U");
	entity_("%fontstyle","S");
	entity_("%fontstyle","STRIKE");
	entity_("%fontstyle","BIG");
	entity_("%fontstyle","SMALL");

	entity_("%phrase","EM");
	entity_("%phrase","STRONG");
	entity_("%phrase","DFN");
	entity_("%phrase","CODE");
	entity_("%phrase","SAMP");
	entity_("%phrase","KBD");
	entity_("%phrase","VAR");
	entity_("%phrase","CITE");
	entity_("%phrase","ABBR");
	entity_("%phrase","ACRONYM");

	entity_("%special","A");
	entity_("%special","IMG");
	entity_("%special","APPLET");
	entity_("%special","OBJECT");
	entity_("%special","FONT");
	entity_("%special","BASEFONT");
	entity_("%special","BR");
	entity_("%special","SCRIPT");
	entity_("%special","MAP");
	entity_("%special","Q");
	entity_("%special","SUB");
	entity_("%special","SUP");
	entity_("%special","SPAN");
	entity_("%special","BDO");
	entity_("%special","IFRAME");

	entity_("%formctrl","INPUT");
	entity_("%formctrl","SELECT");
	entity_("%formctrl","TEXTAREA");
	entity_("%formctrl","LABEL");
	entity_("%formctrl","BUTTON");

	entity_("%inline","#text");
	entity_("%inline","%fontstyle");
	entity_("%inline","%phrase");
	entity_("%inline","%special");
	entity_("%inline","%formctrl");

	allowchild_("%fontstyle","%inline");
	allowchild_("%phrase","%inline");
	allowchild_("SUB","%inline");
	allowchild_("SUP","%inline");
//	allowchild_("SPAN","%inline"); // many violations here with start.com (they want %block or %flow)
	allowchild_("BDO","%inline");
//	allowchild_("FONT","%inline"); // ditto
	allowchild_("FONT","%flow");	// nobody seems to care about proper positioning of FONT tags
	allowchild_("SPAN","%flow"); // This is definitely wrong, DIV is for block elements and SPAN for inline

	entity_("%block","P");
	entity_("%block","NOBR");  // Netscape extension...
	entity_("%block","%heading");
	entity_("%block","%list");
	entity_("%block","%preformatted");
	entity_("%block","DL");
	entity_("%block","DIV");
	entity_("%block","CENTER");
	entity_("%block","NOSCRIPT");
	entity_("%block","NOFRAMES");
	entity_("%block","BLOCKQUOTE");
	entity_("%block","FORM");
	entity_("%block","ISINDEX");
	entity_("%block","HR");
	entity_("%block","TABLE");
	entity_("%block","FIELDSET");
	entity_("%block","ADDRESS");

	entity_("%flow","%block");
	entity_("%flow","%inline");
	entity_("%flow", "STYLE"); // bloody Netscape stupidities

	allowchild_("NOBR", "%flow");  // Netscape extension...

	allowchild_("BODY","%flow");
	allowchild_("ADDRESS","%inline");
	allowchild_("ADDRESS","P");
	allowchild_("DIV","%flow");
	allowchild_("CENTER","%flow");

	allowchild_("A","%inline");

	allowchild_("MAP","%block");
	allowchild_("MAP","AREA");

	allowchild_("OBJECT", "PARAM");
	allowchild_("OBJECT", "%flow");
	allowchild_("APPLET", "PARAM");
	allowchild_("APPLET", "%flow");

	allowchild_("P", "%inline");
	allowchild_("%heading", "%inline");
	allowchild_("PRE", "%inline");
	allowchild_("Q", "%inline");
	allowchild_("BLOCKQUOTE", "%flow");

	allowchild_("DL", "DT");
	allowchild_("DL", "DD");
	allowchild_("DL", "HR");       // Nonstandard, but xxx.lanl.gov uses it.
	allowchild_("DL", "%heading"); // Nonstandard, but xxx.lanl.gov uses it.
	allowchild_("DT", "%inline");
	allowchild_("DT", "%heading"); // Nonstandard, but xxx.lanl.gov uses it.
	allowchild_("DD", "%flow");
	allowchild_("OL", "LI");
	allowchild_("UL", "LI");

	// Illegal, but nobody seems to care and there's no good way to
	// recover from these errors.
	allowchild_("OL", "P");
	allowchild_("UL", "P");
	allowchild_("DL", "P");

	// This is not legal, but it is used almost everywhere to get 
	// indentation.
	allowchild_("OL", "%flow");
	allowchild_("UL", "%flow");
	allowchild_("DL", "%flow");

	allowchild_("DIR", "LI");
	allowchild_("MENU", "LI");
	allowchild_("LI", "%flow");

	allowchild_("FORM", "%flow");
	allowchild_("LABEL", "%inline");

	entity_("%InputType", "TEXT");
	entity_("%InputType", "PASSWORD");
	entity_("%InputType", "CHECKBOX");
	entity_("%InputType", "RADIO");
	entity_("%InputType", "SUBMIT");
	entity_("%InputType", "RESET");
	entity_("%InputType", "FILE");
	entity_("%InputType", "HIDDEN");
	entity_("%InputType", "IMAGE");
	entity_("%InputType", "BUTTON");

	allowchild_("SELECT", "OPTGROUP");
	allowchild_("SELECT", "OPTION");
	allowchild_("OPTGROUP", "OPTION");
	allowchild_("OPTION", "#text");
	allowchild_("TEXTAREA", "#text");
	allowchild_("FIELDSET", "#text");
	allowchild_("FIELDSET", "LEGEND");
	allowchild_("FIELDSET", "%flow");
	allowchild_("LEGEND", "%inline");
	allowchild_("BUTTON", "%flow");

   // optional optional tags should be forbidden
	entity_("%tbody", "TR");
	entity_("%tbody", "TD");

	allowchild_("TABLE", "CAPTION");
	allowchild_("TABLE", "COL");
	allowchild_("TABLE", "COLGROUP");
	allowchild_("TABLE", "THEAD");
	allowchild_("TABLE", "TFOOT");
	allowchild_("TABLE", "TBODY");
	allowchild_("TABLE", "%tbody");
	allowchild_("CAPTION", "%inline");
	allowchild_("THEAD", "TR");
	allowchild_("TBODY", "TR");
	allowchild_("TFOOT", "TR");
	allowchild_("COLGROUP", "COL");
	allowchild_("TR", "TH");
	allowchild_("TR", "TD");
	allowchild_("TH", "%flow");
	allowchild_("TD", "%flow");

	allowchild_("FRAMESET", "FRAMESET");
	allowchild_("FRAMESET", "FRAME");
	allowchild_("FRAMESET", "NOFRAMES");
	allowchild_("FRAME", "#text"); // ILLEGAL
	allowchild_("IFRAME", "%flow");
	entity_("%noframes.content", "%flow");

	entity_("%head.content", "TITLE");
	entity_("%head.content", "ISINDEX");
	entity_("%head.content", "BASE");
	allowchild_("HEAD", "%head.content");
	allowchild_("HEAD", "%head.misc"); // not quite ok, but close enough
	allowchild_("TITLE", "#text");

	entity_("%html.content", "HEAD");
	entity_("%html.content", "BODY");
	entity_("%html.content", "FRAMESET");
	allowchild_("HTML", "%html.content");
		

	pos_("HEAD","%head.misc");

	neg_("A","A");

/*	neg_("PRE","%pre.exclusion");
	neg_("DIR","%block");
	neg_("MENU","%block");
	neg_("FORM","FORM");
	neg_("LABEL","LABEL");
	neg_("BUTTON","A");
	neg_("BUTTON","%formctrl");
	neg_("BUTTON","FORM");
	neg_("BUTTON","ISINDEX");
	neg_("BUTTON","FIELDSET");
	neg_("BUTTON","IFRAME");
	neg_("TITLE","%head.misc"); */


	rawtext.insert("SCRIPT");
	rawtext.insert("STYLE");
	keepwhite.insert("PRE");
	

   optstart.insert("HTML");
   optstart.insert("HEAD");
   optstart.insert("TBODY");
   optstart.insert("BODY");
//   optstart.insert("P");   // this is to force every #text node in a P if you disallow text anywhere.
// No matter how nice and clean this is, it is probably better to put that logic in 
// the renderer.


	optend.insert("BASEFONT");
	optend.insert("BR");
	optend.insert("AREA");
	optend.insert("LINK");
	optend.insert("IMG");
	optend.insert("PARAM");
	optend.insert("HR");
	optend.insert("P");
	optend.insert("DT");
	optend.insert("DD");
	optend.insert("LI");
	optend.insert("INPUT");
	optend.insert("OPTION");
	optend.insert("THEAD");
	optend.insert("TFOOT");
	optend.insert("COLGROUP");
	optend.insert("COL");
	optend.insert("TR");
	optend.insert("TD");
	optend.insert("FRAME");
	optend.insert("ISINDEX");
	optend.insert("BASE");
	optend.insert("META");

	empty.insert("BASEFONT");
	empty.insert("BR");
	empty.insert("AREA");
	empty.insert("LINK");
	empty.insert("IMG");
	empty.insert("PARAM");
	empty.insert("HR");
	empty.insert("INPUT");
	empty.insert("COL");
//	empty.insert("FRAME");
	empty.insert("ISINDEX");
	empty.insert("BASE");
	empty.insert("META");


	// additional junk I do not understand
	allowchild_("SCRIPT","#text");
	allowchild_("STYLE","#text");
	allowchild_("NOSCRIPT","%inline");


// We need to have a class which contains info about one possible attribute:
// the name, type of data (text, number, etc) and the default value, if any.

//	entity_("%coreattrs", 

/*	const_iterator it=entities.begin();
	while(it!=entities.end()) {
		cout << (*it).first << " belongs to entity " << (*it).second << endl;
		++it;
		}
	const_iterator it2=allow.begin();
	while(it2!=allow.end()) {
		cout << (*it2).first << " allows child " << (*it2).second << endl;
		++it2;
		}*/
	}

