// -*- mode: C++; c-file-style: "mnemonic"; -*-

/*
  Mnemonic xml parser implementation.

  Please send bugs, changes, problems to bugs@mnemonic.browser.org

  This program and its components are free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.
 
  This program and its components are distributed in the hope that it
  will be useful, but WITHOUT ANY WARRANTY; without even the implied
  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
  the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License in
  the file COPYING accompanying this program; if not, write to the
  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <string>
#include "xmlparser.hh"
#include <msg/dom/parse_error.hh>

#define DEBUG_CLASS "XMLPARSER"
#include "mnemonic/debug.hh"

void xmlparser::send_error(long linenum, const string& err)
	{
	msg_parse_error msg(url_string(document->url().c_str()), linenum, err);
	try {
		msg.send();
		}
	catch(messagebase_error& ex) {
		debug("no-one interested in error message");
		debug("for error at line " << linenum);
		}
	}
